      program autodrm 
c
c     Urs Kradolfer, 30.3.91
c
c     Revisions: 24.7.91, 26.7.91, 5.9.91, 6.9.91, 5.11.91, 25.1.92,
c                11.5.92
c                26.6.92 changed subr. datum
c                2.9.92  added option ALERT
c                2.1.93  all open-statments immediately after FREEFILE-calls
c                6.4.93  new stations added (now: 17 stations)
c                10./11.4.93 some format changes made
c                4.6.93  several comments added (and on 25.6.93)
c                15.7.93 subr. splitmailfile modified
c                19.7.93 FTP-option extended: AutoDRM now FTP's if so desired!
c                7.9.93 make sure, only KPfiles with length=14 are used!
c                25.1.94 if sender is postmaster, respond to autodrm-operator!!
c                25.1.94 subr. checknoforward added
c                28.2.94 subr. SENDamiOUTPUTdate added
c                7.3.94  files from MO-disks may also be accessed!
c                15.4.94 Check for strange files on /signals/kp in EXEC improved
c                28.2.94 Code modified so it is independent of environment
c                30.5.94 Don't respond to the same request within 10 minutes!
c                31.8.94 Program autodrm.exe is called once for each request!
c                01.09.94 Check for postmaster etc. done at program beginning!
c                10.12.94 Error in subr. checkfordifferentmail fixed
c                11.12.94 Subr. pleasehelp substituted by subr. help .
c                16.12.94 V2.0 adapted to GSE2.0
c                18.12.94 V2.1: AutoDRM now 'understands' old AND GSE2.0 formats
c                20.12.94 V2.2: FTP-option as GSE2.0 added & several bugs fixed
c                21.12.94 Subr. checkcdat modified
c                21.12.94 default for resultok im write*_ex.f subrs. is .true.
c                22.12.94 subr. searchbackslash deleted & better code in gettask
c                22.12.94 write 'From:'-line to log-part of response
c                26.12.94 allow dropping of leading zeros in TIME format
c                27.12.94 code 'cleaned' and included observatoryname in output
c                29.12.94 subr. exec slightly modified
c                30.12.94 Default for STATION, WAVEFORM etc. is GSE2.0
c                30.12.94 Output-formats modified (especially for SED-features)
c                30.12.94 intermediate Version V2.3 now ready!
c                01.01.95 Bug in subr. checkcdat fixed!
c                02.01.95 - Small 'free-format'-bug in subr. convtime fixed
c                         - subrs. ftphandler and ftpgse2handler extended
c                         - users-log-file contains improved info for FTP-option
c                         - allow autodrm-operator to set maxfilesize
c                         - option 'large' removed, superusers activated!
c                         - for too large response-files: automatically set 
c                           FTP-option or reject request if still too large
c                02.01.95 Version V2.4 ready.
c                04.01.95 Ignore blank lines in requests and report it
c                04.01.95 Bug in subr. ftphandler fixed
c                11.01.95 Quite a few users mistyped the 'E-MAIL' command;
c                         Allow both the commands E-MAIL and E_MAIL
c                12.01.95 Reporting, if STA-, CHAN- or AUX-list is overwritten
c                12.01.95 Code cleaned ('done'-stuff removed)
c                16.01.95 Bug in subr. ftphandler fixed (thanks Reinoud Sleeman)
c                24.01.95 Bug in subr. datum fixed (error at 31.Dec 00:00)
c                24.01.95 Version V2.41 ready.
c                02.02.95 autodrm_watcher.com modified (ls -l instead of ls)
c                15.02.95 'SunOS-Bug' @line 430 removed (thanks Reinoud Sleeman)
c                15.02.95 Version V2.42 ready.
c                24.04.95 new filestructure for the whole AutoDRM-package
c                24.04.95 request for CODECO is now read more flexible
c                25.04.95 'From:'-lines longer than 80 characters now supported
c                27.04.95 subr. getfilesize modified
c                27.04.95 subr. getsystem modified
c                27.04.95 runtime added (cf. log-file)
c                01.05.95 00:00 UTC: from now on UTC time used in log-file
c                14.05.95 subr. countlines modified
c                15.05.95 Version V2.5 ready
c                16.05.95 Subr. exec modified
c                16.05.95 Script 'Configure' (and others) modified
c                01.06.95 Version V2.51 ready
c                06.06.95 runtime could be > 9999 sec; set then runtime to 9999
c                06.06.95 bug in subr. checkcdat fixed (ideltamin was always 0)
c                06.06.95 possible bug in subr. countlines fixed
c                06.06.95 send no response if sender's emailaddress is autodrm
c                06.06.95 same requests and trieste-mailer messages are
c                         not written to autodrm.log any more but rather sent
c                         to autodrm-operator (file autodrm.log now contains
c                         only _real_ errors during execution of AutoDRM)
c                07.06.95 subr. getemailaddress modified
c                07.06.95 AutoDRM now returns the response to the sender's
c                         e-mail address if no return e-mail address is given
c                07.06.95 subr. uservalidity added: it is now possible to
c                         restrict AutoDRM usage to certain e-mail addresses
c                         (see subr. uservalidity for further comments)
c                08.06.95 call of subr. waveform modified - the AutoDRM
c                         commands WAVEF and WAVEFORM are now treated similar
c                08.06.95 Version V2.6 ready
c                09.06.95 call of subr. writeresponse modified
c                         (included il, ie; deleted sec1, cdat2, sec2)
c                09.06.95 subr. HELP was called twice - bug fixed
c                12.06.95 subr. filecheck and help modified (search only in the
c                         first few lines of a mail for 'BEGIN' or 'HELP'
c                12.06.95 modified programs splitmailfile and autodrm
c                         for better security against mails from mailer-daemons.
c                         AutoDRM now sends such mails to the autodrm-operator
c                         even if GSE2.0-format is somehow detected
c                12.06.95 GSE2.0 messages were not correctly checked for
c                         multiple requests by same user within same 10 minutes;
c                         bug fixed
c                12.06.95 all the GSE2.0 subr. (writewaveform, writeoutage,
c                         writestation, writechannel, writeresponse) now
c                         allow to give output units for log- and error-log-
c                         messages. You do not have to use them, but it is
c                         necessary to declare these variables.
c                12.06.95 Calib-command is now allowed again in order to be
c                         back-compatible to the 'old' AutoDRM format
c                13.06.95 New version of program 'codeco' included in directory
c                         'res'. Karl Koch implemented the GSE2.0 format.
c                13.06.95 Users Guide in autodrm.help modified and updated
c                13.06.95 Version V2.7 ready
c                25.09.95 bug at line 1122 removed: .or.ftpgse2format  added!
c                28.10.95 AutoDRM now also runs on operating system AIX (IBM)
c                28.10.95 Check publicstation also, if STA_LIST is given!
c                29.10.95 Version V2.71 ready
c                11.11.95 Program 'codeco' (included in directory ~res) modified
c                         (correct hang/vang values)
c                11.11.95 Version V2.8 ready
c                14.11.95 Small change for operating system AIX in file
c                         ~/prog/autodrm.com (mailfile-size must be > 0)
c                14.11.95 Version V2.81 ready
c                14.12.95 Do not reply if sender is 'Unreplyable!SMTP...'
c                         This modification was also done in splitmailfile.f
c                12.01.96 added status='old' in open-statement in subr. usertype
c                12.01.96 Small change in subr. freefile for OpSys OSF1
c                12.01.96 Small change in subr. updatelogfile for OSF1
c                12.01.96 Some code in subr. exec commented (c96)
c                12.01.96 Version V2.82 ready
c                18.03.96 modified subr. splitstring (Thanks to Donat Faeh)
c                28.03.96 remove leading blanks in lines after the e-mail header
c                         (this is done in program splitmailfile; see there)
c                30.04.96 subr. timeclear added to subr. convtime
c                30.05.96 Preparations for AutoDRM on operating system Linux
c                16.06.96 Allow EMAIL, E-MAIL, E_MAIL without a blank between
c                         this command and the e-mail address given afterwards!
c                21.07.96 modified SED-routine writestation/writechannel
c                22.07.96 replaced trmlen by trimlen in subr. splitstring!!!
c                15.08.96 subr. TIMECLEAR was NOT part of the code; now it is...
c                16.09.96 get_opsys.com und Configure adjusted for Solaris
c                         5.5 and higher (thanks to Klaus Stammler)
c                21.01.97 subr. ftphandler modified (ftp.cmd and ftp.log
c                         files were not removed after usage).
c                04.05.97 /bin/cp, /bin/ls and /bin/diff instead of \cp, \ls 
c                         \diff
c                04.05.97 Some f77-compilers (e.g. g77) are not able to under-
c                         stand concatenated strings where the length of the
c                         string is a function: str1//str2(1:trimlen(str2))
c                         --> all such code changed.
c                04.05.97 Version V2.83 ready
c                14.11.97 subr. getfilesize modified (use 'awk' to get size)
c                14.11.97 Version V2.84 ready
c                26.03.98 Subr. init: operating systems OSF1 and Linux added
c                21.05.98 subst. logical gse2format by character*10 gseformat
c                21.05.98 allow for requests for bulletin, origin, arrival, ...
c                17.06.98 Version V2.9 ready
c                04.05.99 writebulletin did not get start/end date if interval
c                         was not specified with TIME command: now, date1 and
c                         date2 commands work as well
c                18.05.99 checked code for the Y2K-problem: modified subr.
c                         convtime; subr. juliam and datum would have worked for
c                         the year 2000, but not for the year 2400 :-) ---
c                         therefore replaced them by juliam2 & datum2
c                08.06.99 Allow parallel processing of requests; see file
c                         autodrm.com for details
c                09.06.99 Subr. exec streamlined and made sure, that also for
c                         bulletin requests a time interval must be specified
c                09.06.99 GSE-format has two meanings: 1) for the way of how
c                         AutoDRMs 'speak' to each other and 2) how waveform-
c                         or bulletin data is sent. Now we introduce separate
c                         variables for these cases (waveformformat &
c                         bulletinformat). This requires changes in the 
c                         subrs. writewaveform and writebulletin !
c                09.06.99 Version V2.91 ready
c                10.06.99 Subr. exec: variable waveformformat incorrectly
c                         declared... bug fixed.
c                10.06.99 Version V2.92 ready
c                06.10.99 Subr. writebulletin: variable bulletinformat not
c                         taken by subr... bug fixed.
c                06.10.99 Version V2.93 ready
c                16.11.99 vorbereiten fuer versch. Samplingraten...
c                10.01.00 First implementation of Waves4U...
c                01.02.00 Subr. ftphandler modifified: if 'INTER' is set, send
c                         file to pub-Directory of the anonymous ftp-account
c                16.03.00 make copy of request-mail, which is not deleted
c                         when AutoDRM crashes; helps to find out errors...
c                16.03.00 Clarified some of the error messages
c                25.04.00 Subr. convtime: check for months > 12 in a request
c                19.05.00 Subr. getmsgid modified: read until BEGIN is found,
c                         not only until end of header. For compliance with
c                         the S/MIME standard. Thanks to David Salzberg, CMR.
c                03.06.00 Version V2.94 ready
c                08.08.00 writewaves4u_local.f was missing in the distribution
c                08.08.00 Version V2.95 ready
c                18.02.01 Script Configure modified (if . is not in PATH)
c                18.02.01 subr. checkfordifferentmail modified: diff instead of
c                         /bin/diff (because of Linux)
c                18.02.01 autodrm e-mail address is now also included in
c                         the file ~/adm/autodrm.rc
c                18.02.01 Version V2.96 ready
c                08.03.01 If a line contains one of the following characters
c                         <>;$ or if line starts with  '-' then write an
c                         error message and go to next task line
c                09.03.01 Magnitude_TypeList is now given to subr. writebulletin
c                         and is also correctly read in the main program
c                         --> so file writebulletin_local.f has changed!
c                15.03.01 Scripts STARTautodrm.com and STOPautodrm.com in the
c                         ~/adm directory modified (if . is not in PATH)
c                21.03.01 Version V2.97 ready
c                23.03.01 Modified get_opsys.com and Configure for Solaris 5.6
c                23.03.01 Modified writewaves4u_local.f: removed unneeded
c                         variables
c                23.03.01 Version V2.98 ready
c                24.04.01 Modified writewaveform.f (now: wave_extractor)
c                03.05.01 variable wrongtask is now reset, if taskline
c                         contains an illegal character (avoid infinite loop)
c                12.05.01 Version V2.99 ready
c                17.05.01 Modifed subr. convtime: check for more parameters
c                         in date/time for meaningful values
c                16.11.01 program splitmailfile.f modified (see there)
c                16.11.01 there *must* be a blank between EMAIL and e-mail addr.
c                16.11.01 code modified and added for anti-spam measures
c                08.01.02 anti-spam measures modified (allow 'BEGIN     GSE')
c                24.04.02 in subr. filecheck allow Outlook Express headers...
c                28.04.02 in subr. filecheck allow more Outlook Express headers
c                29.04.02 Version V3.00alpha ready
c                01.05.02 subr. spamcheck added
c                17.05.02 added new rules to subr. spamcheck
c                19.07.03 Version V3.00beta ready
c
c>>>  Program to be run every minute (UNIX: via crontabs !).
c>>>  If there is mail for user autodrm, the mail is automatically
c>>>  processed and a response mail is sent.
c>>>  Program should be installed using the 'Configure' script, which
c>>>  adjusts the routines for the specific operating system.
c
      implicit none
c
      integer maxcommands
c
      parameter(maxcommands=200)  ! max. no. of commands per mail
c 
      integer it, is, ie, ih, il, ilin, i, isbytes,ifbytes,
     &        trimlen, ncommands, trimbeg, maxfilesize, israte
      real sec1,sec2, srate
      character string*200, taskline*1024,
     &          emailaddress*100, tryemailaddress*100, 
     &          origtryemailaddress*100,
     &          sendfile*80, task*20, errorfile*80,
     &          cdat1*12,cdat2*12, cstartdate*20,
     &          templogfile*80, subject*75, creceivedate*20,
     &          ftpfilename*80, internetaddress*80, useraddress*100, 
     &          mailprogram*80, helpfile*80, observatoryname*80,
     &          superuserfile*80, codecoprog*80, logfile*80,
     &          ftpdir*80, operatoraddress*80, userftpdir*80,
     &          cdatami1*12,cdatami2*12, badsender*80,
     &          msgid*30, reflin*80, beglin*80, sourceid*7,
     &          csec1*10, csec2*10, cipnumber*50, sysnam*5,
     &          cexecstarttime*20, gseformat*10, timestring*70,
     &          waveformformat*10, bulletinformat*10,
     &          autodrmemailaddress*100
      character*50 clatminmax, clonminmax, cdepthminmax, cndefminmax,
     &             cnstaminmax, cmagtypelist, cmagminmax, cgapminmax,
     &             cbulltype
      character*80 tempfile, headerfile,datalogfile, requestmail,
     &             commands(maxcommands), comment, allowfile, denyfile,
     &             spamheadfile, spambodyfile
      character*1024 stalist, chanlist, auxlist
      logical lexist, stopnotfound,startnotfound, public, quiet,
     &        ftp, helperli, superuser, noforward,
     &        taskerror, resultok, ftpgse2format,
     &        sendppicks,sendwavef, forcedftp, rejectmail, validuser,
     &        sendcalib, wrongtask, spam
c
c     Get starting time of this autodrm-run:
c
      call DATETIMEUTC(cexecstarttime)
c
c     read the initialization file  autodrm.rc and define some settings:
c
      call INIT(observatoryname,sourceid,mailprogram,helpfile,
     &          superuserfile,codecoprog,logfile,ftpdir,userftpdir,
     &          operatoraddress,cipnumber,sysnam,maxfilesize,
     &          allowfile,denyfile,autodrmemailaddress,
     &          spamheadfile,spambodyfile)
c
c     - incoming mail is stored (by the system) in a special file
c     - autodrm.com saves new mail using your mailprogram and savemail.cmd
c     - program splitmailfile splits all new mail in seperate files
c     - autodrm.com renames one request after the other to 'current.mail'
c
c     --> if there was mail, the first mail to handle is now stored 
c         in file current.mail
c     To be absolutely sure, check if this file really exists:
c 
      inquire(file='current.mail',exist=lexist)
      if(.not.lexist)then
          goto 3000  ! no new (saved) mail --> end
      else
         requestmail='request.mail'
         call FREEFILE(requestmail)
         string='cp current.mail '//requestmail
         call system(string)
         call FILES(requestmail,'new')
      endif
c
c     First, let's have a look whether this is spam mail; if it is spam,
c     we just drop the mail: no reply and no forwarding to the
c     autodrm-operator (just a small entry into the logfile):
c
      tempfile='current.mail'
      spam=.false.
      call SPAMCHECK(tempfile,spamheadfile,spambodyfile,logfile,
     &               cexecstarttime,spam)
      if(spam) goto 3000
c
c     reset/initialize some variables:
c
      stopnotfound=.false.
      startnotfound=.false.
      emailaddress=' '
      task=' '
      cdat1=' '
      cdat2=' '
      ncommands=0
      tryemailaddress=' '
      quiet=.false.
      subject=' '
      ftp=.false.
      ftpfilename=' '
      internetaddress=' '
      helperli=.false.
      superuser=.false.
      noforward=.false.
      cdatami1=' '
      cdatami2=' '
      badsender=' '
      gseformat='GSE1.0'
      waveformformat=' '
      bulletinformat=' '
      stalist=' '
      chanlist=' '
      auxlist=' '
      sec1=0.0
      sec2=0.0
      csec1=' '
      csec2=' '
      taskerror=.false.
      ftpgse2format=.false.
      sendppicks=.false.
      sendwavef=.false.
      isbytes=0
      ifbytes=0
      forcedftp=.false.
      rejectmail=.false.
      validuser=.true.
      origtryemailaddress=' '
      sendcalib=.false.
      timestring=' '
      clatminmax=' '
      clonminmax=' '
      cdepthminmax=' '
      cndefminmax=' '
      cnstaminmax=' '
      cmagtypelist=' '
      cmagminmax=' '
      cgapminmax=' '
      cbulltype=' '
      srate=0.0
      israte=0
      autodrmemailaddress=' '
      wrongtask=.false.
c
c     open the current mail-file that has to be processed now:
c
      tempfile='current.mail'
      call FREEUNIT(it)
      open(it,file=tempfile,status='old')
c
c     open the error-file; this is the file, where all the error-messages
c     will be written onto:
c
      errorfile='error.file'
      call FREEUNIT(ie)
      call FREEFILE(errorfile)
      open(ie,file=errorfile,status='unknown')
      call FILES(errorfile,'new')
c
c     open the data_log-file; this file will contain the log-messages:
c
      datalogfile='datalog.file'
      call FREEUNIT(il)
      call FREEFILE(datalogfile)
      open(il,file=datalogfile,status='unknown')
      call FILES(datalogfile,'new')
c
c     open the send-file; this is the file, where all the output (the requested
c     data & information is written):
c
      sendfile='send.file'
      call FREEUNIT(is)
      call FREEFILE(sendfile)
      open(is,file=sendfile,status='unknown')
      call FILES(sendfile,'new')
c
c     open the header-file; this will be on top of the response mail:
c
      headerfile='header.file'
      call FREEUNIT(ih)
      call FREEFILE(headerfile)
      open(ih,file=headerfile,status='unknown')
cccccccccc      call FILES(headerfile,'new')
      call FILES(headerfile,'new')
c
c     check, if the request-mail contains a line that starts with the
c     command 'begin' or 'begin gse2.0' :
c
      call FILECHECK(it,startnotfound,gseformat,beglin)
      if(gseformat.eq.'GSE2.0')then
         write(il,'(a)')'DATA_TYPE log'
         write(ie,'(a)')'DATA_TYPE error_log'
      else
         write(il,'(a)')'### DATA_TYPE log:'
         write(ie,'(a)')'### DATA_TYPE error_log:'
      endif
      if(startnotfound)then
         call HELP(it,helperli)
         if(helperli)then
            continue ! this case is handled later!!
         else
            write(ie,'(a)')'*** Command  BEGIN  not found!'
            write(ie,'(a)')'*** Each request must start '//
     &                     'with this command!'
            ncommands=ncommands+1
            commands(ncommands)='(Command BEGIN not found...)'
c           after having checked for mailer-daemons etc. goto 1000 will come
         endif
      else
         ncommands=ncommands+1
         commands(ncommands)=beglin
         if(gseformat.eq.'GSE2.0')then
            write(il,'(a)')' Got command: '//
     &                          beglin(1:trimlen(beglin))
         else
            write(il,'(a)')'### Got command: '//
     &                          beglin(1:trimlen(beglin))
         endif
      endif
c
      if(gseformat.eq.'GSE1.0'.and..not.startnotfound)then
         write(is,*)
         write(is,'(a)')'### Below follows what you requested '
         write(is,'(a)')'### (unless your request contained a '//
     &                  'severe error!):'
         write(is,*)
      endif
c
c     Check when the current request arrived and write header of response:
c
      call GETRECEIVEDATE(it,creceivedate)
      call DATETIME(cstartdate)
      call WRITEMAILHEADER(ih,creceivedate,cstartdate,gseformat,
     &                     observatoryname)
      if(gseformat.eq.'GSE2.0')then
         write(ih,'(a)')'BEGIN     GSE2.0'
         write(ih,'(a)')'MSG_TYPE  data'
         call MAKEMSGID(msgid,sourceid)    ! our msgid
         write(ih,'(a)')'MSG_ID    '//msgid
         call GETMSGID(it,msgid,reflin)    ! received msgid
         ncommands=ncommands+1
         if(reflin.eq.' ')then
            commands(ncommands)='no MSG_ID received - o.k.'
            write(il,'(a)')' no MSG_ID received - o.k.'
         else
            commands(ncommands)=reflin
            write(il,'(a)')' Got command: '//
     &                     reflin(1:trimlen(reflin))
         endif
         write(ih,'(a)')'REF_ID    '//msgid
      endif
c
      close(ih)
c
c     Check, if this request-mail already is a response from the AutoDRM; if
c     YES, then this could cause an infinite loop!!! Set the 'noforward'-flag,
c     i.e. send response to AutoDRM-operator:
c
      call CHECKNOFORWARD(it,noforward)
      if(noforward) goto 999
c
c     Check, if the sender of the mail is one, to whom we should not
c     send a response (such as mailer-daemons, etc.):
c
      call TRYGETEMAILADDRESS(it,tryemailaddress)
      origtryemailaddress=tryemailaddress   ! save the 'un-casefolded' version
      if(gseformat.eq.'GSE2.0')then
         write(il,'(a)')' Request comes from: '//
     &                  tryemailaddress(1:trimlen(tryemailaddress))
      else
         write(il,'(a)')'### Request comes from: '//
     &                     tryemailaddress(1:trimlen(tryemailaddress))
      endif
      call CASEFOLD(tryemailaddress)
c
      if(INDEX(tryemailaddress,'MAILER-DAEMON').gt.0)then
         if(gseformat.eq.'GSE2.0')then
            write(ie,'(a)')' *** Sender is a MAILER-DAEMON - '//
     &                     'do NOT respond!'
         else
            write(ie,'(a)')'*** Sender is a MAILER-DAEMON - '//
     &                     'do NOT respond!'
         endif
         ncommands=ncommands+1
         commands(ncommands)='(not responded - '//
     &                       'sender is a mailer-daemon...)'
         emailaddress=operatoraddress
         noforward=.true.
         goto 1000
      endif
      if(INDEX(tryemailaddress,'AUTODRM').gt.0)then
         if(gseformat.eq.'GSE2.0')then
            write(ie,'(a)')' *** Sender is a AUTODRM - '//
     &                     'do NOT respond!'
         else
            write(ie,'(a)')'*** Sender is a AUTODRM - '//
     &                     'do NOT respond!'
         endif
         ncommands=ncommands+1
         commands(ncommands)='(not responded - '//
     &                       'sender is an autodrm...)'
         emailaddress=operatoraddress
         noforward=.true.
         goto 1000
      endif
      if(INDEX(tryemailaddress,'POSTMASTER').gt.0)then
         if(gseformat.eq.'GSE2.0')then
            write(ie,'(a)')' *** Sender is a POSTMASTER - '//
     &                     'do NOT respond!'
         else
            write(ie,'(a)')'*** Sender is a POSTMASTER - '//
     &                     'do NOT respond!'
         endif
         ncommands=ncommands+1
         commands(ncommands)='(not responded - '//
     &                       'sender is a postmaster...)'
         emailaddress=operatoraddress
         noforward=.true.
         goto 1000
      endif
      if(INDEX(tryemailaddress,'UNREPLYABLE').gt.0)then
         if(gseformat.eq.'GSE2.0')then
            write(ie,'(a)')' *** Sender is a UNREPLYABLE - '//
     &                     'do NOT respond!'
         else
            write(ie,'(a)')'*** Sender is a UNREPLYABLE - '//
     &                     'do NOT respond!'
         endif
         ncommands=ncommands+1
         commands(ncommands)='(not responded - '//
     &                       'sender is a unreplyable...)'
         emailaddress=operatoraddress
         noforward=.true.
         goto 1000
      endif
c
c     Check, if this request is different from the last one we got (or - if the
c     same - at least 10 minutes younger); if not it may
c     be someone who repeats sending the same request. Do not answer!
c
      call CHECKforDIFFERENTmail(it,creceivedate,badsender)
      rewind(it)
      if(badsender.ne.' ')then
         ncommands=ncommands+1
         commands(ncommands)='(not responded - same request in same'//
     &                       ' 10 minutes from same user)'
         if(gseformat.eq.'GSE2.0')then
            write(ie,'(a)')' *** (not responded - same request in '//
     &                     'same 10 minutes from same user)'
         else
            write(ie,'(a)')'*** (not responded - same request in '//
     &                     'same 10 minutes from same user)'
         endif
         noforward=.true.
         emailaddress=operatoraddress
         goto 1000
      endif
c
c     if the mail contains the string 'help' (used to be 'please help'), send 
c     some basic information about AutoDRM to the sender:
c
      if(helperli)then
         write(il,*)
         write(il,'(a)')' Recognized the string HELP in'//
     &              ' the incoming request!'
         write(il,*)
         tryemailaddress=origtryemailaddress
         call MAKEADDRESS(tryemailaddress,emailaddress,operatoraddress)
         call WRITEHELP(is,emailaddress,operatoraddress,
     &                  autodrmemailaddress)
         ncommands=ncommands+1
         commands(ncommands)='HELP'
cc         call INFOR(is,helpfile)
         goto 1000
      else
         tryemailaddress=origtryemailaddress
         string=origtryemailaddress !for security reasons (mailer-daemon's etc.)
c
         if(startnotfound) goto 1000 ! no BEGIN found in request mail...
c
c        The MAILER from Trieste (Italy) always sends automatic log-files;
c        do not respond to them:
c
         if(tryemailaddress.eq.' MAILER@UTS882.TRIESTE.it')then
            ncommands=ncommands+1
            commands(ncommands)='(not responded - trieste-mailer...)'
            if(gseformat.eq.'GSE2.0')then
               write(ie,'(a)')' *** (not responded - trieste mailer...)'
            else
               write(ie,'(a)')'*** (not responded - trieste mailer...)'
            endif
            noforward=.true.
            emailaddress=operatoraddress
            goto 1000
         endif
c
c        resolve proper e-mail address of sender of request:
c
c      comment next line, if no default address should be resolved:
ccc         call MAKEADDRESS(string,useraddress,operatoraddress)
ccc    if the line above is not commented, the next 2 statements below
ccc    must be commented!
c
c      comment next 2 lines, if default address should not be sender's address:
         call MAKEADDRESS(string,emailaddress,operatoraddress)
         useraddress=emailaddress
c
c        check if user is in the list of 'super-users' and therefore may
c        retriever larger amounts of data:
c
         call USERTYPE(superuserfile,useraddress,superuser)
c
c        Check if this AutoDRM installation restricts access to certain users; 
c        if it does, test if current user is authorized:
c
         call USERVALIDITY(useraddress,allowfile,denyfile,validuser)
         if(.not.validuser)then
            write(ie,'(a)')'***'
            write(ie,'(a)')'*** Your e-mail address '
     &                          //useraddress(1:trimlen(useraddress))
            write(ie,'(a)')'*** is not registered.'
            write(ie,'(a)')'*** Please request a registration by '//
     &                          'sending an e-mail to our AutoDRM '//
     &                          'operator'
            write(ie,'(a)')'*** '
     &                     //operatoraddress(1:trimlen(operatoraddress))
            write(ie,'(a)')'***'
            ncommands=ncommands+1
            commands(ncommands)='(not processed - not registered!)'
            goto 1000
         endif
      endif
c
c     Next 'check' already done; called again to position to start of request:
c
      call FILECHECK(it,startnotfound,gseformat,beglin)
c
c     come here to process the next line of the incoming request:
c
  10  call GETTASK(it,taskline,stopnotfound,gseformat,taskerror,sysnam)
      if(INDEX(taskline,'<').gt.0) wrongtask=.true.
      if(INDEX(taskline,'>').gt.0) wrongtask=.true.
      if(INDEX(taskline,';').gt.0) wrongtask=.true.
      if(INDEX(taskline,'$').gt.0) wrongtask=.true.
      if(taskline(1:1).eq.'-') wrongtask=.true.
      if(wrongtask)then
         write(ie,'(a)')' *** Last command was: '//
     &                          taskline(1:trimlen(taskline))
         write(ie,'(a)')' *** This command was not recognized!'
         write(ie,'(a)')' *** (illegal character in the line?)'
         wrongtask=.false.
         goto 10
      endif
      if(stopnotfound) goto 999
c
      if(taskline.eq.' ')then
         if(gseformat.eq.'GSE2.0')then
            write(il,'(a)')' Got blank line - ignored'
         else
            write(il,'(a)')'### Got blank line - ignored'
         endif
      endif
c
      if(taskline(1:6).eq.'MSG_ID') goto 10   ! already handled above
c
      if(gseformat.eq.'GSE2.0')then
         write(il,'(a)')' Got command: '//taskline(1:trimlen(taskline))
      else
         write(il,'(a)')'### Got command: '//
     &                       taskline(1:trimlen(taskline))
      endif
      ncommands=ncommands+1
      commands(ncommands)=taskline(1:80)
c
c     if an incoming (broken) line was > 1024 characters, report error:
c
      if(taskerror)then
         write(ie,'(a)')' Error: request-line was > 1024 characters'
         goto 999
      endif
c
      if(gseformat.eq.'GSE2.0')then
         if(taskline(1:1).eq.' ') goto 10   ! comment only
         if(taskline(1:1).eq.'(') goto 10   ! comment only
         if(taskline(1:8).eq.'LINE_LEN')then
            write(ie,'(a)')' Command LINE_LEN not (yet) supported'
         endif
         if(taskline(1:8).eq.'MSG_TYPE')then
            if(INDEX(taskline,'REQUEST').gt.0)then
               goto 10  ! o.k., it's a request...
            else
               write(ie,'(a)')' Error: This is no request!'
               goto 999
            endif
         endif
         if(taskline(1:9).eq.'CONTINUED')then
            write(ie,'(a)')' Option CONTINUED not (yet) supported'
            goto 999
         endif
         if(taskline(1:6).eq.'REF_ID')then
            write(ie,'(a)')' Error: This is no request!'
            goto 999
         endif
      endif
c
c     Read time environment specification:
c
      if(taskline(1:4).eq.'TIME')then
         timestring=taskline(1:80)
         call CONVTIME(taskline,cdat1,sec1,cdat2,sec2)
         if(cdat1.eq.'error')then
            if(gseformat.eq.'GSE2.0')then
               write(ie,'(a)')' Error in TIME format'
            else
               write(ie,'(a)')'### Error in TIME format'
            endif
            cdat1=' '
            goto 999
         else
            write(csec1(2:),'(f6.2)') sec1
            i=INDEX(csec1,' .')
            if(i.gt.0) csec1(i:i+1)='0.'
            write(csec2(2:),'(f6.2)') sec2
            i=INDEX(csec2,' .')
            if(i.gt.0) csec2(i:i+1)='0.'
            if(gseformat.eq.'GSE2.0')then
               write(il,'(a)')' StartTime: '//cdat1//' '//
     &                        csec1(trimbeg(csec1):trimlen(csec1))
               write(il,'(a)')' EndTime  : '//cdat2//' '//
     &                        csec2(trimbeg(csec2):trimlen(csec2))
            else
               write(il,'(a)')'### StartTime: '//cdat1//' '//
     &                        csec1(trimbeg(csec1):trimlen(csec1))
               write(il,'(a)')'### EndTime  : '//cdat2//' '//
     &                        csec2(trimbeg(csec2):trimlen(csec2))
            endif
            goto 10
         endif
      endif
c
c     Read station-list, channel-list, auxID-list:
c
      if(taskline(1:8).eq.'STA_LIST')then
         if(stalist.ne.' ')then
            write(il,'(a)')' New STA_LIST command - overwriting'//
     &                     ' old STA_LIST !'
         endif
         stalist=taskline(10:)
         if(.not.superuser)then
            call CHECKSTALIST(stalist,il,ie,gseformat)
         endif
         goto 10
      endif
      if(taskline(1:9).eq.'CHAN_LIST')then
         if(chanlist.ne.' ')then
            write(il,'(a)')' New CHAN_LIST command - overwriting'//
     &                     ' old CHAN_LIST !'
         endif
         chanlist=taskline(11:)
         goto 10
      endif
      if(taskline(1:8).eq.'AUX_LIST')then
         if(auxlist.ne.' ')then
            write(il,'(a)')' New AUX_LIST command - overwriting'//
     &                     ' old AUX_LIST !'
         endif
         auxlist=taskline(10:)
         goto 10
      endif
c
c     Waveforms are requested:
c
      if(taskline(1:8).eq.'WAVEFORM')then
         task='WAVEFORM'
         if(taskline(9:).eq.' ') waveformformat='GSE2.0'
         if(INDEX(taskline,'GSE2.0').gt.0) waveformformat='GSE2.0'
         if(INDEX(taskline,'SEED').gt.0) waveformformat='SEED'
         if(INDEX(taskline,'CSS').gt.0) waveformformat='CSS'
         if(waveformformat.ne.' ')then
            call EXEC(task,is,il,ie,errorfile,cdat1,
     &      cdat2,sec1,sec2,
     &      ftp,sendppicks,
     &      timestring,clatminmax,clonminmax,cdepthminmax,
     &      cndefminmax,cnstaminmax,cmagtypelist,cmagminmax,
     &      cgapminmax,cbulltype,waveformformat,bulletinformat,
     &      gseformat,stalist,chanlist,auxlist)
            goto 10
         else
            write(ie,'(a)')' Error: Do not know what format you want.'
            write(ie,'(a)')' Use  : WAVEFORM GSE2.0'
            write(ie,'(a)')'  or  : WAVEFORM SEED'
            write(ie,'(a)')'  or  : WAVEFORM CSS'
            write(ie,'(a)')'  or any other valid format on this AutoDRM'
            goto 999
         endif
      endif
c
c     Station information is requested:
c
      if(taskline(1:7).eq.'STATION')then
         if(taskline(8:).eq.' '.or.
     &            INDEX(taskline,'GSE2.0').gt.0)then
            write(is,'(a)')'DATA_TYPE station GSE2.0'
            call WRITESTATION(is,il,ie,stalist,resultok,comment)
            if(resultok)then    ! no error
               write(il,'(x,a)') comment(1:trimlen(comment)) !info to logfile
            else
               write(ie,'(x,a)') comment(1:trimlen(comment)) !info to errfile
               goto 999 ! an error occurred
            endif
            goto 10
         else
            write(ie,'(a)')' Error: Do not know what format you want.'
            write(ie,'(a)')' Use  : STATION GSE2.0'
            write(ie,'(a)')' for retrieving station data'
            goto 999
         endif
      endif
c
c     Channel information is requested:
c
      if(taskline(1:7).eq.'CHANNEL')then
         if(taskline(8:).eq.' '.or.
     &            INDEX(taskline,'GSE2.0').gt.0)then
            write(is,'(a)')'DATA_TYPE channel GSE2.0'
            call WRITECHANNEL(is,il,ie,stalist,chanlist,auxlist,
     &                        resultok,comment)
            if(resultok)then    ! no error
               write(il,'(x,a)') comment(1:trimlen(comment)) !info to logfile
            else
               write(ie,'(x,a)') comment(1:trimlen(comment)) !info to errfile
               goto 999 ! an error occurred
            endif
            goto 10
         else
            write(ie,'(a)')' Error: Do not know what format you want.'
            write(ie,'(a)')' Use  : CHANNEL GSE2.0'
            write(ie,'(a)')' for retrieving channel data'
            goto 999
         endif
      endif
c
c     Response information (calibration info) is requested:
c
      if(taskline(1:8).eq.'RESPONSE')then
         if(taskline(9:).eq.' '.or.
     &            INDEX(taskline,'GSE2.0').gt.0)then
            write(is,'(a)')'DATA_TYPE response GSE2.0'
            call WRITERESPONSE(is,il,ie,cdat1,
     &                       stalist,chanlist,auxlist,resultok,comment)
            if(resultok)then    ! no error
               write(il,'(x,a)') comment(1:trimlen(comment)) !info to logfile
            else
               write(ie,'(x,a)') comment(1:trimlen(comment)) !info to errfile
               goto 999 ! an error occurred
            endif
            goto 10
         else
            write(ie,'(a)')' Error: Do not know what format you want.'
            write(ie,'(a)')' Use  : RESPONSE GSE2.0'
            write(ie,'(a)')' for retrieving response data'
            goto 999
         endif
      endif
c
c     Outage information is requested:
c
      if(taskline(1:6).eq.'OUTAGE')then
         if(taskline(7:).eq.' '.or.
     &            INDEX(taskline,'GSE2.0').gt.0)then
            write(is,'(a)')'DATA_TYPE outage GSE2.0'
            call WRITEOUTAGE(is,il,ie,cdat1,sec1,cdat2,sec2,
     &                       stalist,chanlist,auxlist,resultok,comment)
            if(resultok)then    ! no error
               write(il,'(x,a)') comment(1:trimlen(comment)) !info to logfile
            else
               write(ie,'(x,a)') comment(1:trimlen(comment)) !info to errfile
               goto 999 ! an error occurred
            endif
            goto 10
         else
            write(ie,'(a)')' Error: Do not know what format you want.'
            write(ie,'(a)')' Use  : OUTAGE GSE2.0'
            write(ie,'(a)')' for retrieving outage data'
            goto 999
         endif
      endif
c
c     The FTP-option (according to the GSE2.0 format) is specified:
c
      if(taskline(1:3).eq.'FTP')then
         if(INDEX(taskline,'@').gt.0)then  ! emailaddress here --> GSE2.0 format
            ftpgse2format=.true.
            string=taskline(4:200)
            emailaddress=string(trimbeg(string):trimlen(string))
            goto 10
         else
            continue ! 'old' FTP-option is handled later below... (NO goto 10 !)
         endif
      endif
c
c
c
      if(taskline(1:3).eq.'LAT')then
         clatminmax=taskline(1:50) 
         goto 10
      endif
      if(taskline(1:3).eq.'LON')then
         clonminmax=taskline(1:50) 
         goto 10
      endif
      if(taskline(1:5).eq.'DEPTH')then
         cdepthminmax=taskline(1:50) 
         goto 10
      endif
      if(taskline(1:8).eq.'MAG_TYPE')then
         cmagtypelist=taskline(1:50) 
         goto 10
      endif
      if(taskline(1:3).eq.'MAG')then
         cmagminmax=taskline(1:50) 
         goto 10
      endif
      if(taskline(1:9).eq.'BULL_TYPE')then
         cbulltype=taskline(1:50) 
         goto 10
      endif
      if(taskline(1:3).eq.'GAP')then
         cgapminmax=taskline(1:50) 
         goto 10
      endif
      if(taskline(1:4).eq.'NSTA')then
         cnstaminmax=taskline(1:50) 
         goto 10
      endif
      if(taskline(1:4).eq.'NDEF')then
         cndefminmax=taskline(1:50) 
         goto 10
      endif
      if(taskline(1:8).eq.'BULLETIN')then
         if(taskline(9:).eq.' ') bulletinformat='GSE2.0'
         if(INDEX(taskline,'GSE2.0').gt.0) bulletinformat='GSE2.0'
         if(bulletinformat.ne.' ')then
            task='BULLETIN'
            call EXEC(task,is,il,ie,errorfile,cdat1,
     &             cdat2,sec1,sec2,
     &             ftp,sendppicks,
     &             timestring,clatminmax,clonminmax,cdepthminmax,
     &             cndefminmax,cnstaminmax,cmagtypelist,cmagminmax,
     &             cgapminmax,cbulltype,waveformformat,bulletinformat,
     &             gseformat,stalist,chanlist,auxlist)
            goto 10
         else
            write(ie,'(a)')' Error: Do not know what format you want.'
            write(ie,'(a)')' Use  : BULLETIN GSE2.0'
            write(ie,'(a)')' for retrieving bulletin data'
            goto 999
         endif
         goto 10
      endif
      if(taskline(1:6).eq.'ORIGIN')then
         if(taskline(7:).eq.' '.or.
     &            INDEX(taskline,'GSE2.0').gt.0)then
            task='ORIGIN'
            call EXEC(task,is,il,ie,errorfile,cdat1,
     &             cdat2,sec1,sec2,
     &             ftp,sendppicks,
     &             timestring,clatminmax,clonminmax,cdepthminmax,
     &             cndefminmax,cnstaminmax,cmagtypelist,cmagminmax,
     &             cgapminmax,cbulltype,waveformformat,bulletinformat,
     &             gseformat,stalist,chanlist,auxlist)
            goto 10
         else
            write(ie,'(a)')' Error: Do not know what format you want.'
            write(ie,'(a)')' Use  : ORIGIN GSE2.0'
            write(ie,'(a)')' for retrieving origin data'
            goto 999
         endif
         goto 10
      endif
      if(taskline(1:5).eq.'EVENT')then
         if(taskline(6:).eq.' '.or.
     &            INDEX(taskline,'GSE2.0').gt.0)then
            task='EVENT'
            call EXEC(task,is,il,ie,errorfile,cdat1,
     &             cdat2,sec1,sec2,
     &             ftp,sendppicks,
     &             timestring,clatminmax,clonminmax,cdepthminmax,
     &             cndefminmax,cnstaminmax,cmagtypelist,cmagminmax,
     &             cgapminmax,cbulltype,waveformformat,bulletinformat,
     &             gseformat,stalist,chanlist,auxlist)
            goto 10
         else
            write(ie,'(a)')' Error: Do not know what format you want.'
            write(ie,'(a)')' Use  : EVENT GSE2.0'
            write(ie,'(a)')' for retrieving event data'
            goto 999
         endif
         goto 10
      endif
      if(taskline(1:7).eq.'ARRIVAL')then
         if(taskline(8:).eq.' '.or.
     &            INDEX(taskline,'GSE2.0').gt.0)then
            task='ARRIVAL'
            call EXEC(task,is,il,ie,errorfile,cdat1,
     &             cdat2,sec1,sec2,
     &             ftp,sendppicks,
     &             timestring,clatminmax,clonminmax,cdepthminmax,
     &             cndefminmax,cnstaminmax,cmagtypelist,cmagminmax,
     &             cgapminmax,cbulltype,waveformformat,bulletinformat,
     &             gseformat,stalist,chanlist,auxlist)
            goto 10
         else
            write(ie,'(a)')' Error: Do not know what format you want.'
            write(ie,'(a)')' Use  : ARRIVAL GSE2.0'
            write(ie,'(a)')' for retrieving arrival data'
            goto 999
         endif
         goto 10
      endif
c
c     A Waves4U request is coming (code for the Swiss NDC only):
c
      if(taskline(1:7).eq.'WAVES4U')then
         task='WAVES4U'
         call EXEC(task,is,il,ie,errorfile,cdat1,
     &          cdat2,sec1,sec2,
     &          ftp,sendppicks,
     &          timestring,clatminmax,clonminmax,cdepthminmax,
     &          cndefminmax,cnstaminmax,cmagtypelist,cmagminmax,
     &          cgapminmax,cbulltype,waveformformat,bulletinformat,
     &          gseformat,stalist,chanlist,auxlist)
         goto 10
      endif
c
c     an unexpected second BEGIN-line was read:
c
      if(taskline(1:5).eq.'BEGIN')then
         if(gseformat.eq.'GSE2.0')then
            write(ie,'(a)')' Unexpected second BEGIN task - ignored!'
         else
            write(ie,'(a)')'### Unexpected second BEGIN task - ignored!'
         endif
         goto 10
      endif
c
c
c     if the request-mail is read completely (command STOP arrived), see if
c     (according to the 'old' AutoDRM-format) there are any left
c     requests for waveforms, calibrations, or P-picks have to be sent:
c
      if(taskline(1:4).eq.'STOP')then
c
         if(sendwavef)then
            task='WAVEFORM'
            call EXEC(task,is,il,ie,errorfile,cdat1,
     &             cdat2,sec1,sec2,
     &             ftp,sendppicks,
     &             timestring,clatminmax,clonminmax,cdepthminmax,
     &             cndefminmax,cnstaminmax,cmagtypelist,cmagminmax,
     &             cgapminmax,cbulltype,waveformformat,bulletinformat,
     &             gseformat,stalist,chanlist,auxlist)
            write(is,*)
         endif
         if(sendppicks)then
            task='PPICK'
            call EXEC(task,is,il,ie,errorfile,cdat1,
     &             cdat2,sec1,sec2,
     &             ftp,sendppicks,
     &             timestring,clatminmax,clonminmax,cdepthminmax,
     &             cndefminmax,cnstaminmax,cmagtypelist,cmagminmax,
     &             cgapminmax,cbulltype,waveformformat,bulletinformat,
     &             gseformat,stalist,chanlist,auxlist)
            write(is,*)
         endif
         if(sendcalib)then
            write(is,'(a)')'DATA_TYPE response GSE2.0'
            call WRITERESPONSE(is,il,ie,cdat1,
     &                       stalist,chanlist,auxlist,resultok,comment)
            if(resultok)then    ! no error
               write(il,'(x,a)') comment(1:trimlen(comment)) !info to logfile
            else
               write(ie,'(x,a)') comment(1:trimlen(comment)) !info to errfile
               goto 999 ! an error occurred
            endif
            write(is,*)
         endif
c
         goto 1000
      endif
c
c     the source code of program 'codeco' is requested:
c
      if(taskline(1:5).eq.'SOURC')then
ccc         if(taskline(7:12).eq.'CODECO')then  ! improved on 24.4.95
         if(INDEX(taskline(7:),'CODECO').gt.0)then
            call SENDCODECO(is,codecoprog)
         else
            write(ie,'(a)')'*** WHAT source would you like???'
         endif
         goto 10
      endif
c
c     the user's guide is requested:
c
      if(taskline(1:5).eq.'INFOR'.or.taskline(1:4).eq.'HELP'.or.
     &                               taskline(1:5).eq.'GUIDE')then
         call INFOR(is,helpfile)
         goto 10
      endif
c
c     a subject (title) of the mail to be returned is specified:
c
      if(taskline(1:5).eq.'TITLE'.or.taskline(1:5).eq.'SUBJE')then
         subject=taskline(7:80)
         goto 10
      endif
c
c     the requested output should be sent via anonymous FTP; if this fails,
c     the output is stored locally (here!) to be retrieved
c     later by the user; send only a short response mail with the filename
c     of the response mail:
c
      if(taskline(1:3).eq.'FTP')then
         if(INDEX(taskline,'@').eq.0)then ! if '@' is here, it's GSE2.0 !!!!!
            ftp=.true.
            string=taskline(4:200)
            ftpfilename=string(trimbeg(string):trimlen(string))
         endif
         goto 10
      endif
c
c     the FTP-option requires the internet-address (in the numerical form):
c
      if(taskline(1:5).eq.'INTER')then
         string=taskline(6:200)
         internetaddress=string(trimbeg(string):trimlen(string))
         goto 10
      endif
c
c     the start of a time interval is specified:
c
      if(taskline(1:5).eq.'DATE1')then
         read(taskline(7:),'(a)',end=999,err=999) cdat1
         if(taskline(19:).ne.' ')then
            write(ie,'(a)')'*** Possible error in specification '//
     &                          'of DATE1 !'
            write(ie,'(a)')'*** DATE1 must be of the form: YYYYMMDDHHMM'
         endif
         if(cdat1(1:2).ne.'19'.and.cdat1(1:2).ne.'20')then
            write(ie,'(a)')'*** Error in specification of DATE1 !'
            write(ie,'(a)')'*** DATE1 must be of the form: YYYYMMDDHHMM'
         endif
         goto 10
      endif
c
c     the end of a time interval is specified:
c
      if(taskline(1:5).eq.'DATE2')then
         read(taskline(7:),'(a)',end=999,err=999) cdat2
         if(taskline(19:).ne.' ')then
            write(ie,'(a)')'*** Possible error in specification'//
     &                         ' of DATE2 !'
            write(ie,'(a)')'*** DATE2 must be of the form: YYYYMMDDHHMM'
         endif
         if(cdat2(1:2).ne.'19'.and.cdat2(1:2).ne.'20')then
            write(ie,'(a)')'*** Error in specification of DATE2 !'
            write(ie,'(a)')'*** DATE2 must be of the form: YYYYMMDDHHMM'
         endif
         goto 10
      endif
c
c     the detections/locations are desired:
c
      if(taskline(1:5).eq.'DETEC')then
         task='DETEC'
         call EXEC(task,is,il,ie,errorfile,cdat1,
     &             cdat2,sec1,sec2,
     &             ftp,sendppicks,
     &             timestring,clatminmax,clonminmax,cdepthminmax,
     &             cndefminmax,cnstaminmax,cmagtypelist,cmagminmax,
     &             cgapminmax,cbulltype,waveformformat,bulletinformat,
     &             gseformat,stalist,chanlist,auxlist)
         goto 10
      endif
c
c      a waveform of a station is desired:
c
      if(taskline(1:5).eq.'WAVEF')then
         call PUBLICSTATION(taskline(7:11),public)
         if(public.or.superuser)then
            sendwavef=.true.
            if(taskline(7:).ne.' ')then ! there is a station name here
               if(stalist.eq.' ')then
                  stalist=taskline(7:11)
               else
                  stalist=stalist(1:trimlen(stalist))//', '//
     &                                         taskline(7:11)
               endif
            endif
         else
            write(ie,'(a)')'*** Station '
     &                         //taskline(7:11)//' not available!'
         endif
         goto 10
      endif
c
c     calibration information of a station is desired:
c
      if(taskline(1:5).eq.'CALIB')then
         call PUBLICSTATION(taskline(7:11),public)
         if(public.or.superuser)then
            sendcalib=.true.
            if(taskline(7:).ne.' ')then ! there is a station name here
               if(stalist.eq.' ')then
                  stalist=taskline(7:11)
               else
                  stalist=stalist(1:trimlen(stalist))//', '//
     &                                         taskline(7:11)
               endif
            endif
         else
            write(ie,'(a)')'*** Station '
     &                         //taskline(7:11)//' not available!'
         endif
         goto 10
      endif
c
c     P-picks are desired:
c
      if(taskline(1:5).eq.'PPICK')then
         call PUBLICSTATION(taskline(7:11),public)
         if(public.or.superuser)then
            sendppicks=.true.
            if(taskline(7:).ne.' ')then ! there is a station name here
               if(stalist.eq.' ')then
                  stalist=taskline(7:11)
               else
                  stalist=stalist(1:trimlen(stalist))//', '//
     &                                         taskline(7:11)
               endif
            endif
         else
            write(ie,'(a)')'*** Station '//taskline(7:11)
     &                     //' not available!'
         endif
         goto 10
      endif
c
c     a list of available waveforms is desired:
c
      if(taskline(1:5).eq.'AVAIL')then
         task='AVAIL'
         call EXEC(task,is,il,ie,errorfile,cdat1,
     &             cdat2,sec1,sec2,
     &             ftp,sendppicks,
     &             timestring,clatminmax,clonminmax,cdepthminmax,
     &             cndefminmax,cnstaminmax,cmagtypelist,cmagminmax,
     &             cgapminmax,cbulltype,waveformformat,bulletinformat,
     &             gseformat,stalist,chanlist,auxlist)
         goto 10
      endif
c
c     a station list is desired:
c
      if(taskline(1:5).eq.'SLIST')then
         task='SLIST'
         call EXEC(task,is,il,ie,errorfile,cdat1,
     &             cdat2,sec1,sec2,
     &             ftp,sendppicks,
     &             timestring,clatminmax,clonminmax,cdepthminmax,
     &             cndefminmax,cnstaminmax,cmagtypelist,cmagminmax,
     &             cgapminmax,cbulltype,waveformformat,bulletinformat,
     &             gseformat,stalist,chanlist,auxlist)
         goto 10
      endif
c
c     the e-mail address, where the response mail has to be sent to, is
c     specified:
c
      if(taskline(1:6).eq.'EMAIL ')then
         emailaddress=taskline(7:105)
         call CHECKEMAILADDRESS(emailaddress)
         goto 10
      endif
      if(taskline(1:7).eq.'E-MAIL ')then ! GSE2.0 format
         emailaddress=taskline(8:105)
         call CHECKEMAILADDRESS(emailaddress)
         goto 10
      endif
      if(taskline(1:7).eq.'E_MAIL ')then !GSE2.0 format
         write(il,'(a)')' Command <'//taskline(1:7)//'> unknown!'
         write(il,'(a)')' Assuming you meant <E-MAIL> and taking '//
     &                   'your E-Mail address'
         emailaddress=taskline(8:105)
         call CHECKEMAILADDRESS(emailaddress)
         write(ie,'(a)')' as: '//emailaddress(8:trimlen(emailaddress))
         goto 10
      endif
c
c     a list of the 'associated locations' is desired:
c     (this is very specific for the Swiss NDC; just leave the code here;
c     appropriate dummy-routines are already provided for you)
c
      if(taskline(1:5).eq.'AMI A')then
         cdatami1=cdat1(1:12)
         cdatami2=cdat2(1:12)
         if(cdatami1.eq.' '.or.cdatami2.eq.' ')then
            if(gseformat.eq.'GSE2.0')then
               write(is,'(a)')'DATA_TYPE sed-ami-a'
            endif
            call SENDamiOUTPUT(is)
         else
            if(gseformat.eq.'GSE2.0')then
               write(is,'(a)')'DATA_TYPE sed-ami-a'
            endif
            call SENDamiOUTPUTdate(is,cdatami1,cdatami2)
         endif
         goto 10
      endif
c
      if(taskline(1:5).eq.'SRATE')then
         read(taskline(6:),*,err=777) srate
         israte=NINT(srate)
         write(il,'(a,i4,a)')' Desired sampling rate is ',israte,' Hz'
         goto 10
 777     write(ie,'(a)')' Error reading sampling rate !'
         write(ie,'(a)')' The default sampling rate will be used.'
         goto 10
      endif
c
c     the command line just read is not a valid one:
c
      if(gseformat.eq.'GSE2.0')then
         write(ie,'(a)')' *** Last command was: '//
     &                          taskline(1:trimlen(taskline))
         write(ie,'(a)')' *** This command was not recognized!'
      else
         write(ie,'(a)')'*** Last command was: '//
     &                          taskline(1:trimlen(taskline))
         write(ie,'(a)')'*** This command was not recognized!'
      endif
      goto 10
c
c     come here if an error occurred while reading the mailfile
c
  999 continue
      if(gseformat.eq.'GSE2.0')then
         write(ie,'(a)')' *** unexpected error or end detected!'
      else
         write(ie,'(a)')'*** unexpected error or end detected!'
      endif
      if(stopnotfound)then
         if(gseformat.eq.'GSE2.0')then
            write(ie,'(a)')' ***'
            write(ie,'(a)')' *** The word  STOP  on the last '
     &                 //'line of your request was missed!'
            write(ie,'(a)')' ***'
         else
            write(ie,'(a)')'***'
            write(ie,'(a)')'*** The word  STOP  on the last '
     &                 //'line of your request was missed!'
            write(ie,'(a)')'***'
         endif
      endif
      write(is,*)
c
c     come here to finalize the response for one request mail:
c
 1000 continue
c
      if(gseformat.eq.'GSE2.0')then
         write(is,'(a)')'STOP'
      else
         if(.not.noforward)then
            write(is,*)
            write(is,'(a)')'### Below follows the request '//
     &                 'we received from you:'
            write(is,*)
         endif
      endif
c
c     If response will be sent to the AutoDRM operator...
c
      if(noforward)then
         write(is,*)
         write(is,'(a)')'### Below follows the request we received:'
         write(is,*)
      endif
      close(is)
c
      if(gseformat.eq.'GSE1.0'.and..not.noforward)then
         write(il,'(a)')'###'
         write(il,'(a)')'### (A copy of your request mail is included'//
     &              ' at the end)'
         write(il,'(a)')'###'
         write(il,*)
      endif
      close(ie)
c
      close(il)
c
      string='cat '//datalogfile(1:trimlen(datalogfile))//' >> '//
     &               headerfile(1:trimlen(headerfile))
      call system(string)
      call COUNTLINES(ie,errorfile,ilin)
      if(ilin.gt.1)then ! there are errors reported in the errorfile!
         string='cat '//errorfile(1:trimlen(errorfile))//' >> '//
     &                  headerfile(1:trimlen(headerfile))
         call system(string)
      endif
      string='cat '//sendfile(1:trimlen(sendfile))//' >> '//
     &               headerfile(1:trimlen(headerfile))
      call system(string)
c
      if(gseformat.eq.'GSE1.0'.or.noforward)then
         string='cat '//tempfile(1:trimlen(tempfile))//' >> '//
     &                  headerfile(1:trimlen(headerfile))
         call system(string)
      endif
c
      sendfile=headerfile
c
c     the 'sendfile' now contains the whole information that has to be
c     sent to the requsting user
c
c
c     check request-mail if no emailaddress found so far
c     (must be checked again: if an error has occurred the request
c      mail may not have been read completely):
c
      if(emailaddress.eq.' ')then
         call GETEMAILADDRESS(it,emailaddress)
         call CHECKEMAILADDRESS(emailaddress)
      endif
c
c     if no e-mail-address is available, send the output to the operator:
c
      if(emailaddress.eq.' ') emailaddress=operatoraddress
c
c     if noforward-flag was set, send output to operator:
c
      if(noforward) emailaddress=operatoraddress
c
c     Set appropriate MaxFileSize (default is set in autodrm.rc):
c     (typical default is maxfilesize = 100000 bytes = 100 kilobytes)
c
      if(ftp.or.ftpgse2format) maxfilesize=10*maxfilesize ! typically 1 MegaByte
      if(superuser) maxfilesize=10*maxfilesize ! 1 MB (super) / 10 MB(super&ftp)
c
c     get size of file to send:
c     (if file is transferred using ftp, correct size will be stored below)
c
      call GETFILESIZE(sendfile,'size.fil',isbytes) ! size of MAIL-file
c
c     Now check, if response-file is not too large:
c     (if too large, set ftp option or reject request-mail!)
c
      if(isbytes.gt.maxfilesize)then
         if(ftp.or.ftpgse2format)then
            rejectmail=.true.
         else
            if(gseformat.eq.'GSE2.0')then
               ftpgse2format=.true.
            else
               ftp=.true.
            endif
            maxfilesize=10*maxfilesize
            if(isbytes.gt.maxfilesize)then
               rejectmail=.true. ! event *with* ftp-option: file is too large!
            else
               forcedftp=.true.
            endif
         endif
      endif
c
c     now actually send the response mail via e-mail:
c
      if(ftp.and.emailaddress.ne.operatoraddress)then
         call FTPHANDLER(sendfile,ftpdir,ftpfilename,internetaddress,
     &                   cipnumber,userftpdir,forcedftp,rejectmail)
         ifbytes=isbytes ! size of FTP-file
         call GETFILESIZE(sendfile,'size.fil',isbytes) ! size of MAIL-file
         call SENDaMAIL(mailprogram,subject,emailaddress,sendfile)
      else
         if(ftpgse2format.and.emailaddress.ne.operatoraddress)then
            call FTPGSE2HANDLER(it,sendfile,sourceid,
     &                          ftpdir,cipnumber,userftpdir,
     &                          forcedftp,rejectmail)
            ifbytes=isbytes ! size of FTP-file
            call GETFILESIZE(sendfile,'size.fil',isbytes) ! size of MAIL-file
            call SENDaMAIL(mailprogram,subject,emailaddress,sendfile)
         else
            call SENDaMAIL(mailprogram,subject,emailaddress,sendfile)
         endif
      endif
c
c     If an error occurred at an early stage of the processing of a request,
c     the sender's e-mail address might not yet be known:
c
      if(origtryemailaddress.eq.' ')then
         call TRYGETEMAILADDRESS(it,origtryemailaddress)
      endif
c
c     update the AutoDRM log-file:
c     (unless program is running at the Swiss Seismological Service
c     and request is coming from a special program on our machine)
c
      if(observatoryname(1:20).eq.'Swiss Seismological '.and.
     &      origtryemailaddress.eq.
     &      ' MailWatch  <mwatch@seismo.ifg.ethz.ch>')then
         continue
      else
         call UPDATELOGFILE(ncommands,commands,emailaddress,
     &                   origtryemailaddress,templogfile,sendfile,
     &                   logfile,isbytes,ifbytes,rejectmail,
     &                   cexecstarttime)
      endif
c
      close(it)
c
c     come here if everything is processed:
c
 2000 continue
      call system('sleep 10')  ! wait 10 seconds (until mail is sent!)
c
c     come here if no request mail was found:
c
 3000 continue
c
c      The next line may be commented for debugging purposes:
c
         call FILES(' ','rem')
c
      end ! of program autodrm
c
c     this is the end of the main program of AutoDRM
c==============================================================================
c
      subroutine GETTASK(it,taskline,stopnotfound,gseformat,taskerror,
     &                   sysnam)
c
c     read a new task-line of the incoming request
c
      implicit none
c
      integer it, trimbeg, i, i1
      character*(*) taskline
      character task*5, string*1024, line*1024, tline*2048, sysnam*5,
     &          gseformat*10
      logical stopnotfound, taskerror
c
      stopnotfound=.false.
      i1=1
c
c     Make sure, that line breaks '\' are handled properly
c     Max. 1024 characters per incoming line; if we find a line-break,
c     we add the next line to the previous one and delete the '\'-character.
c     Totally not more than 1024 characters may be in one complete line:
c
  1   read(it,'(a)',end=998) line
      tline(i1:)=line
cc      i=INDEX(tline,'\')             ! this command does NOT work on SunOS !!!
      i=INDEX(tline,CHAR(92))    ! integer code for '\' is '92'
      if(i.eq.0)then
         i1=1
      else
         tline(i:)=' '
         i1=i
         if(i1.gt.1024)then
            taskline=tline(1:1024)
            taskerror=.true.
            RETURN
         endif
         goto 1
      endif
      taskline=tline(1:1024)
c
      if(gseformat.eq.'GSE2.0')then
         if(taskline(1:1).ne.' '.and.taskline(1:1).ne.'(') 
     &      call CASEFOLD(taskline)
         RETURN
      endif
c
      string=taskline
      taskline=string(trimbeg(string):)
      task=taskline(1:5)
      call CASEFOLD(task)
      if(task(1:3).eq.'FTP')then
         string=taskline
         taskline=task(1:3)//'   '//string(4:)
         task(4:5)=' '
      endif
      if(.not.(task.eq.'TITLE'.or.
     &         task.eq.'SUBJE'.or.
     &         task.eq.'FTP'))then
         call CASEFOLD(taskline)
      else
         taskline=task//taskline(6:)  ! do not casefold title of job (=subject)
      endif
c
      RETURN
c
  998 stopnotfound=.true.
      RETURN
      end ! of subr. gettask
c
      subroutine GETEMAILADDRESS(it,emailaddress)
c
c     search the incoming request for a given e-mail address
c
      implicit none
      integer it
      character*(*) emailaddress
      character*80 cline
c
      rewind(it)
c
   1  read(it,'(a)',end=999,err=999) cline
      if(cline.eq.' ') goto 1                  ! read until end of mail-header
c
   2  read(it,'(a)',end=999,err=999) cline
      call CASEFOLD(cline)
      if(cline.eq.'STOP') goto 999 ! search only until end of message
      if(cline(1:6).eq.'EMAIL ')then
         read(cline(7:),'(a)',end=999,err=999) emailaddress
         RETURN
      endif
      if(cline(1:7).eq.'E-MAIL ')then ! GSE2.0
         read(cline(8:),'(a)',end=999,err=999) emailaddress
         RETURN
      endif
      if(cline(1:7).eq.'E_MAIL ')then ! not GSE2.0, but accepted as well...
         read(cline(8:),'(a)',end=999,err=999) emailaddress
         RETURN
      endif
      goto 2
c
 999  RETURN
      end ! of subr. getemailaddress
c
      subroutine INFOR(is,helpfile)
c
c     write the user's guide of the autodrm to the file to be sent
c
      implicit none
      integer is, ii, trimlen
      character*(*) helpfile
      character*80 cline
c
      write(is,'(a)')'DATA_TYPE comment'
      write(is,*)
c
      call FREEUNIT(ii)
      open(ii,file=helpfile,status='old')
      read(ii,'(a)',end=999) cline ! skip first line with:  . autodrm
 1    read(ii,'(a)',end=999) cline
      write(is,'(a)') cline(1:trimlen(cline))
      goto 1
c
 999  close(ii)
c
      RETURN
      end ! of subr. infor
c
      subroutine FILECHECK(it,startnotfound,gseformat,beglin)
c
c     check, if the incoming file is an AutoDRM request mail
c
      implicit none
      integer it, i, trimlen, n
      character line*80, beglin*80, gseformat*10
      logical startnotfound
c
c     First, skip the header of the mail:
c
   1  read(it,'(a)',end=999) line
      if(line.ne.' ') goto 1
c
c     Now check, if a line is starting with BEGIN or BEGIN GSE2.0 :
c
      i=0
   2  read(it,'(a)',end=999) line
      if(line.eq.' ') goto 2  ! do not count blank lines
      if(line(1:5).eq.'-----') goto 2  ! lines: --- body part 1 ---   etc.
      if(line(1:16).eq.'This is a multi-') goto 2  ! Outlook Express Header...
      if(line(1:8).eq.'Content-') goto 2  ! Outlook Express Header...
      if(INDEX(line,'charset=').gt.0) goto 2  ! Outlook Express Header...
      if(line(1:20).eq.'Messaggio in formato') goto 2  ! Outlook Express Header...
      i=i+1
      call CASEFOLD(line)
      if(line(1:5).eq.'BEGIN')then
         n=trimlen(line)
         if(n.gt.20) goto 2                                     ! anti-spam
         if(.not.(line(6:13).eq.'        '
     &        .or.line(6:9) .eq.' GSE'
     &        .or.line(6:10).eq.'  GSE'
     &        .or.line(6:11).eq.'   GSE'
     &        .or.line(6:12).eq.'    GSE'
     &        .or.line(6:13).eq.'     GSE'
     &        .or.line(6:9) .eq.' IMS'
     &        .or.line(6:10).eq.'  IMS'
     &        .or.line(6:11).eq.'   IMS'
     &        .or.line(6:12).eq.'    IMS'
     &        .or.line(6:13).eq.'     IMS'
     &      ))then                     ! anti-spam
            goto 2
         endif
         beglin=line
         if(INDEX(line,'GSE2.0').gt.0) gseformat='GSE2.0'
         RETURN
      endif
      if(i.gt.3) goto 999 ! search only for first 2-3 lines in a mail
      goto 2
c
 999  startnotfound=.true.
      beglin=' '
      RETURN
      end ! of subr. filecheck
c
      subroutine EXEC(task,is,il,ie,errorfile,
     &                cdat1,cdat2,sec1,sec2,
     &                ftp,sendppicks,
     &             timestring,clatminmax,clonminmax,cdepthminmax,
     &             cndefminmax,cnstaminmax,cmagtypelist,cmagminmax,
     &             cgapminmax,cbulltype,waveformformat,bulletinformat,
     &             gseformat,stalist,chanlist,auxlist)
c
c     in this subr. the actual tasks depending on the requests are done
c     or scheduled
c
      implicit none
      integer maxdatafiles
      parameter(maxdatafiles=1500) ! max. no. of events possible per mail
c
      integer is, ie, il, ideltamin, trimlen
      real sec1,sec2
      character*(*) task,cdat1,cdat2,
     &              errorfile
      character comment*80, gseformat*10, timestring*70,
     &          waveformformat*10, bulletinformat*10
      character*1024 stalist,chanlist,auxlist
      character*50 clatminmax, clonminmax, cdepthminmax, cndefminmax,
     &             cnstaminmax, cmagtypelist, cmagminmax, cgapminmax,
     &             cbulltype
      logical ftp, resultok, sendppicks
c
      if(task.eq.' ')then
         write(ie,'(a)')'*** Unclear, what you requested:'
         write(ie,'(a)')'*** specify WAVEF or DETEC or AVAIL or CALIB!'
      endif
c
      if(task.eq.'SLIST')then
         call WRITESLIST(is,il,ie,resultok)
         RETURN
      endif
c
      if(task.eq.'WAVES4U')then
         call WRITEWAVES4U(is,il,ie,clatminmax,clonminmax,gseformat,
     &                     stalist,chanlist,resultok,comment)
         RETURN
      endif
c
c     From here on, only tasks where a time interval must be specified
c     should appear:
c
      call CHECKCDAT(cdat1,sec1,cdat2,sec2,il,ie,gseformat,
     &                     ideltamin,resultok)
c
      if(.not.resultok)then
         RETURN
      endif
c
      if(task.eq.'BULLETIN'.or.task.eq.'ORIGIN'.or.
     &   task.eq.'EVENT'.or.task.eq.'ARRIVAL')then
         if(ideltamin.gt.527040)then
            write(ie,'(a)')' Error: You cannot retrieve more than '//
     &                     '1 year of bulletin or similar data!'
            write(ie,'(a)')' -----> Use a smaller time interval'
            RETURN
         endif
         if(timestring.eq.' ')then
            write(timestring,'(''TIME'',x,a4,''/'',a2,''/'',a2,
     &                         x,a2,'':'',a2 )') cdat1(1:4),cdat1(5:6),
     &                         cdat1(7:8),cdat1(9:10),cdat1(11:12)
            if(cdat2.ne.' ')then
               write(timestring(23:),'(''TO'',x,a4,''/'',a2,''/'',a2,
     &                         x,a2,'':'',a2 )') cdat2(1:4),cdat2(5:6),
     &                         cdat2(7:8),cdat2(9:10),cdat2(11:12)
            endif
         endif
         call WRITEBULLETIN(is,il,ie,timestring,
     &                      clatminmax, clonminmax,
     &                      cdepthminmax, cndefminmax,
     &                      cnstaminmax, cgapminmax,
     &                      cmagtypelist,cmagminmax, cbulltype,
     &                      task,                   ! outputtype
     &                      gseformat, bulletinformat, stalist,
     &                      resultok,comment)
         RETURN
      endif
c
      if(task.eq.'WAVEFORM')then  ! data from the continuous buffer
         if(stalist.eq.' ')then
            if(gseformat.eq.'GSE2.0')then
               write(ie,'(a)')' Error: no stations defined!'
               write(ie,'(a)')' Use:  STA_LIST stnname [,stnname]'
               write(ie,'(a)')' for retrieving waveforms'
            else
               write(ie,'(a)')'*** Error: no stations defined!'
               write(ie,'(a)')'*** Use:  STA_LIST stnname [,stnname]'
               write(ie,'(a)')'*** for retrieving waveforms'
            endif
            RETURN
         endif
         if(ideltamin.gt.1441)then
c                        THIS value should depend on the channels...
c                        OK for LP-channels - for SP- or BB-channels: lower!!
            write(ie,'(a)')' Error: You cannot retrieve more than '//
     &                     '1441 minutes of waveform data!'
            write(ie,'(a)')' -----> Use a smaller time interval'
            RETURN
         endif
         write(is,'(a)')'DATA_TYPE waveform '//waveformformat
         call WRITEWAVEFORM(is,il,ie,cdat1,sec1,cdat2,sec2,
     &                      gseformat, waveformformat,
     &                      stalist, chanlist,auxlist,
     &                      resultok,comment)
         if(resultok)then    ! no error
            write(il,'(x,a)') comment(1:trimlen(comment)) !info to logfile
         else
            write(ie,'(x,a)') comment(1:trimlen(comment)) !info to errfile
         endif
         RETURN
      endif
c
      if(task.eq.'PPICK')then
         if(.not.sendppicks)then
            write(ie,'(a)')'*** no stations (for ppicks) specified!'
            RETURN
         endif
         if(ideltamin.gt.1440)then
            write(ie,'(a)')'*** error: ppick time interval > 1 day!'
            write(ie,'(a)')'*** -----> use a smaller time interval!'
            RETURN
         endif
         if(gseformat.eq.'GSE2.0')then
            write(is,'(a)')'DATA_TYPE sed-ppick'
         else
            write(is,*)
            write(is,'(a)')'### Below follow the '//
     &              'P-picks you requested '
     &              //'(time format: YYYYMMDD HHMMsec):'
            write(is,*)
         endif
         call WRITEPICKS(cdat1,sec1,cdat2,sec2,stalist,
     &                   is,il,ie,gseformat,resultok)
      endif
c
      if(task.eq.'DETEC')then
         if(ideltamin.gt.527040)then
            write(ie,'(a)')'*** error: detection time interval'//
     &                 ' > 366 days!'
            write(ie,'(a)')'*** -----> use a smaller time interval!'
            RETURN
         endif
         if(gseformat.eq.'GSE2.0')then
            write(is,'(a)')'DATA_TYPE sed-detec'
         endif
         call WRITEDETEC(cdat1,sec1,cdat2,sec2,is,il,ie,
     &                   gseformat,resultok)
      endif
c
      if(task.eq.'AVAIL')then
         if(gseformat.eq.'GSE2.0')then
            write(is,'(a)')'DATA_TYPE sed-avail'
         endif
         call WRITEAVAILABLE(cdat1,sec1,cdat2,sec2,is,il,ie,
     &                   gseformat,resultok)
      endif
c
      RETURN
c
      end ! of subr. exec
c
      subroutine SENDaMAIL(mailprogram,subject,emailaddress,sendfile)
c
c     now send the output of the AutoDRM to the sender
c
      implicit none
      integer trimlen
      character*(*) mailprogram,subject,emailaddress,sendfile
      character string*300
c
c     mailx is better than elm !
c     elm eliminates the double-quote in an address of the type:
c     \"psi%024037153022::che\"@janus.vmsmail.ethz.ch
c     elm understands these double-quotes only if the address is 'aliased'
c     in the file $HOME/.elm/aliases.text !!!
c
      if(subject.eq.' ') subject='Swiss AutoDRM Response'
c
      if(emailaddress(1:4).eq.'PSI%')then
         emailaddress='\"'//emailaddress(1:trimlen(emailaddress))//
     &                '\"@janus.vmsmail.ethz.ch'
      endif
      if(emailaddress(1:3).eq.'FAX')then
         emailaddress='\"\\/x121=9'//
     &                emailaddress(4:trimlen(emailaddress))//
     &                '\\/\"@arcom.ch'
      endif
      if(emailaddress(1:3).eq.'TLX')then
         emailaddress='\"\\/x121=8'//
     &                emailaddress(4:trimlen(emailaddress))//
     &                '\\/\"@arcom.ch'
      endif
cc      string='mailx -s '//
      string=mailprogram(1:trimlen(mailprogram))//' -s '//
     &       '"'//subject(1:trimlen(subject))//'" '//
     &          emailaddress(1:trimlen(emailaddress))//
     &          ' < '//sendfile(1:trimlen(sendfile))//
     &         ' > /dev/null'
      call system(string)
c
      RETURN
      end ! of subr. sendamail
c
      subroutine UPDATELOGFILE(ncommands,commands,emailaddress,
     &                         tryemailaddress,templogfile,sendfile,
     &                         logfile,isbytes,ifbytes,rejectmail,
     &                         cexecstarttime)
c
c     store this run of the AutoDRM in the logfile
c
      implicit none
      integer ncommands, i,k, trimlen, isbytes,ifbytes, irunsec
      real ksbytes, kfbytes, kbytes
      character*(*) commands(ncommands), emailaddress, tryemailaddress,
     &              sendfile, logfile, cexecstarttime
      character templogfile*80, string*200, cdate*20, testlogfile*80,
     &          cexecendtime*20
      logical rejectmail
c
      call FREEUNIT(i)
      templogfile='templog.file'
      call FREEFILE(templogfile)
      open(i,file=templogfile,status='unknown')
      call FILES(templogfile,'new')
      call DATETIME(cdate)
      write(i,'('' DATE: '',a,'' UTC'')') cexecstarttime
      write(i,'('' USER: '',a)') 
     &                     tryemailaddress(1:trimlen(tryemailaddress))
      write(i,'('' SENT: '',a)') emailaddress(1:trimlen(emailaddress))
      do k=1,ncommands
         if(commands(k)(1:1).eq.'(')then
           write(i,'('' INFO: '',a)')commands(k)(1:trimlen(commands(k)))
         else
           write(i,'('' TASK: '',a)')commands(k)(1:trimlen(commands(k)))
         endif
      enddo
      if(ncommands.eq.0)write(i,*)'INFO: (no task found!)'
      ksbytes=float(isbytes)/1000.
      write(i,'(1x,''SIZE: '',f9.3,'' kbytes via Mail'')') ksbytes
      if(ifbytes.gt.0)then
         kfbytes=float(ifbytes)/1000.
         if(rejectmail)then
            write(i,'(1x,''SIZE: '',f9.3,'' kbytes via FTP;'',x,
     &                ''NOT sent - request rejected! '')') kfbytes
            kbytes=ksbytes
         else
            write(i,'(1x,''SIZE: '',f9.3,'' kbytes via FTP'')') kfbytes
            kbytes=kfbytes
         endif
      else
         kbytes=ksbytes
      endif
c
      call DATETIMEUTC(cexecendtime)
      call TIMEDIFF(cexecstarttime,cexecendtime,irunsec)
      if(irunsec.gt.9999) irunsec=9999
      write(i,'(1x,''RUNT:'',i4,'' seconds runtime'')') irunsec
c
      k=trimlen(tryemailaddress)
      if(k.gt.39) k=39
      write(i,'(''ACCESS:'',a,'','',f6.0,'' kbytes, USER:'',a)')
     &      cexecstarttime(1:12),kbytes,tryemailaddress(1:k)
      close(i)
      testlogfile=logfile
      call FREEFILE(testlogfile)
      if(testlogfile.eq.logfile)then  ! logfile does not already exist
         string='touch '//logfile(1:trimlen(logfile))
         call system(string)
      endif
      string='cat '//templogfile(1:trimlen(templogfile))//
     &        ' >> '//logfile
      call system(string)
c
      RETURN
      end ! of subr. updatelogfile
c
      subroutine TRYGETEMAILADDRESS(it,tryemailaddress)
c
c     independant of what the requesting person gave as his return e-mail
c     address, find out WHO has sent this mail to AutoDRM
c
      implicit none
      integer it
      character*(*) tryemailaddress
      character*105 cline
c
      rewind(it)
   1  read(it,'(a)',end=999,err=999) cline
      if(cline(1:5).eq.'From:')then
         read(cline(6:),'(a)',end=999,err=999) tryemailaddress
         RETURN
      endif
      goto 1
 999  RETURN
      end ! of subr. trygetemailaddress
c
      subroutine WRITEMAILHEADER(ih,creceivedate,cstartdate,gseformat,
     &                           observatoryname)
c
c     write the header of the output of the AutoDRM
c
      implicit none
      integer ih, trimlen
      character*(*) creceivedate,cstartdate, observatoryname
      character gseformat*10
c
      if(gseformat.eq.'GSE2.0')then
         write(ih,'(a)')' This output was generated fully '//
     &              'automatically by the'
         write(ih,'(a)')' Swiss AutoDRM: Automatic Data Request '//
     &                   'Manager (V3.00beta)  running at the'
         write(ih,'(a,a)')' ',
     &                    observatoryname(1:trimlen(observatoryname))
         write(ih,'(a)')
         write(ih,'(a,a,a)')' Your request arrived at : ',
     &              creceivedate(1:trimlen(creceivedate)),' local time'
         write(ih,'(a,a,a)')' The  AutoDRM started at : ',
     &              cstartdate(1:trimlen(cstartdate)),' local time'
         write(ih,'(a)')
      else
         write(ih,'(a)')'### This output was generated fully '//
     &              'automatically by the'
         write(ih,'(a)')'### Swiss AutoDRM: '//
     &                  'Automatic Data Request Manager (V3.00beta) '//
     &                  'running at the'
         write(ih,'(a,a)')'### ',
     &                   observatoryname(1:trimlen(observatoryname))
         write(ih,'(a)')'###'
         write(ih,'(a,a,a)')'### Your request arrived at : ',
     &              creceivedate(1:trimlen(creceivedate)),' local time'
         write(ih,'(a,a,a)')'### The  AutoDRM started at : ',
     &              cstartdate(1:trimlen(cstartdate)),' local time'
         write(ih,'(a)')'###'
      endif
c
      RETURN
      end ! of subr. writemailheader
c
      subroutine NUM2CHARMONTH(imo,cmo)
c
c     convert the 'number' of the month into 'words'
c
      implicit none
      integer imo
      character*3 cmo
      character*3 cm(12)
      data cm/'Jan','Feb','Mar','Apr','May','Jun',
     &        'Jul','Aug','Sep','Oct','Nov','Dec'/
c
      cmo=' '
c
      if(imo.lt.1) stop'NUM2CHARMONTH>>> imonth less than 1 ...'
      if(imo.gt.12) stop'NUM2CHARMONTH>>> imonth greater than 12 ...'
ccc      if(imo.lt.1.or.imo.gt.12)then
ccc         ier=1
ccc         RETURN
ccc      endif
c
      cmo=cm(imo)
c
      RETURN
      end ! of subr. num2charmonth
c
      subroutine GETRECEIVEDATE(it,creceivedate)
c
c     get the date/time when the incoming request mail was received here
c
      implicit none
      integer it
      character creceivedate*(*)
      character*250 cline
c
      creceivedate=' '
      rewind(it)
      read(it,'(a)',end=999) cline
      call MAILTEST(cline,creceivedate)   ! get receivedate of mail
c
 999  rewind(it)
      RETURN
      end ! of subr. getreceivedate
c
      subroutine FILES(filename,task)
c
c     a) remember the names of the files that are created during this run
c     b) remove the 'remembered files'
c
      implicit none
      integer i, nfiles, iflag, trimlen
      character*(*) filename
      character*80 usedfiles(1000)
      character task*3, string*150
      save nfiles,iflag,usedfiles
c
      if(iflag.ne.12345678)then
         iflag=12345678
         nfiles=0
      endif
      if(task.eq.'new')then
         nfiles=nfiles+1
         usedfiles(nfiles)=filename
         RETURN
      endif
      if(task.eq.'rem')then
         do i=1,nfiles
            string='/bin/rm -f '//usedfiles(i)(1:trimlen(usedfiles(i)))
     &                       //' > /dev/null'
            call system(string)
         enddo
         RETURN
      endif
      stop'FILES>>> illegal task!'
      end ! of subr. files
c
      subroutine FTPHANDLER(sendfile,ftpdir,ftpfilename,
     &                      internetaddress,cipnumber,userftpdir,
     &                      forcedftp,rejectmail)
c
c     set-up the response mail in case the requesting person wants to retrieve
c     the AutoDRM-output later via ftp
c
      implicit none
      integer i,k, trimlen
      character*80 sendfile, ftpdir, ftpfilename, internetaddress,
     &             userftpdir
      character string*200, filename*100, line*80, cipnumber*50,
     &          ftpcommandfile*80, ftpoutfile*80
      logical ftpok1,ftpok2, forcedftp, rejectmail
c
      ftpok1=.false.
      ftpok2=.false.
c
c     if internet-address is given, send complete response via ftp and
c     the FTP-outputfile via e-mail:
c
      if(internetaddress.ne.' ')then
         if(ftpfilename.eq.' ') ftpfilename='AutoDRM.response'
         ftpcommandfile='ftp.cmd'
         call FREEFILE(ftpcommandfile)
         call FILES(ftpcommandfile,'new')
         call FREEUNIT(i)
         open(i,file=ftpcommandfile,status='new')
         write(i,'(a)')'open '//
     &                  internetaddress(1:trimlen(internetaddress))
         write(i,'(a)')'user ftp ftp'
         write(i,'(a)')'cd pub'  ! new 1.2.2000
         write(i,'(a)')'send '//sendfile(1:trimlen(sendfile))//
     &                        ' '//ftpfilename(1:trimlen(ftpfilename))
         write(i,'(a)')'quit'
         close(i)
         ftpoutfile='ftp.log'
         call FREEFILE(ftpoutfile)
         call FILES(ftpoutfile,'new')
         string='ftp -nv < '//
     &           ftpcommandfile(1:trimlen(ftpcommandfile))//
     &           ' > '//
     &           ftpoutfile(1:trimlen(ftpoutfile))
         call system(string)
         call FREEUNIT(k)
         open(k,file=sendfile,status='old')
         write(k,*)'        YOUR REQUEST HAS BEEN PROCESSED '
         write(k,*)'         BY THE SWISS   A U T O D R M'
         write(k,*)
         write(k,*)
c
         call FREEUNIT(i)
         open(i,file=ftpoutfile,status='old')
  10     read(i,'(a)',end=888) line
         if(INDEX(line,'PORT command successful').gt.0) ftpok1=.true.
         if(INDEX(line,'Transfer complete').gt.0) ftpok2=.true.
         goto 10
 888     close(i)
c
         if(ftpok1.and.ftpok2)then
            write(k,'(a)')'FTP-command seems to have been SUCCESSFUL !'
            write(k,'(a)')'==========================================='
         else
            write(k,'(a)')'FTP-command seems to have been FAILED !'
            write(k,'(a)')'======================================='
         endif
         write(k,*)
         write(k,'(a)')'Below follows the output generated by FTP:'
         write(k,*)
         close(k)
         string='cat '//ftpoutfile(1:trimlen(ftpoutfile))//' >> '//
     &                  sendfile(1:trimlen(sendfile))
         call system(string)
         RETURN
      endif
c
c     if NO internetaddress was given, store response here locally and
c     send instructions on how the user can retrieve the data:
c
      if(.not.rejectmail)then
         if(ftpfilename.ne.' ')then
            k=trimlen(ftpfilename)
            do i=1,k
               if(ftpfilename(i:i).eq.'/') ftpfilename(i:i)='_'
               if(ftpfilename(i:i).eq.' ') ftpfilename(i:i)='_'
            enddo
            filename=ftpdir(1:trimlen(ftpdir))
     &               //ftpfilename(1:trimlen(ftpfilename))
         else
            filename=ftpdir(1:trimlen(ftpdir))//'response'
         endif
         call FREEFILE(filename)
         string='/bin/cp '//sendfile(1:trimlen(sendfile))//' '
     &                 //filename(1:trimlen(filename))
         call system(string)
      endif
c
      call FREEUNIT(k)
      open(k,file=sendfile,status='old')
      write(k,*)'        YOUR REQUEST HAS BEEN PROCESSED '
      write(k,*)'         BY THE SWISS   A U T O D R M'
      write(k,*)
      if(rejectmail)then
            write(k,'(a)')' The original request could not be satisfied'
            write(k,'(a)')' using e-mail due to the large size of the'
            write(k,'(a)')' requested information; FTP was tried '//
     &                    'instead.'
            write(k,'(a)')' However, even for FTP-usage the size of'
            write(k,'(a)')' the requested information was too large.'
            write(k,'(a)')' THEREFORE YOUR REQUEST WAS REJECTED!'
            write(k,'(a)')' Please submit a new request that will'
            write(k,'(a)')' result in a smaller response-file.'
      else
         if(forcedftp)then
            write(k,'(a)')' The original request could not be satisfied'
            write(k,'(a)')' using e-mail due to the large size of the'
            write(k,'(a)')' requested information; FTP was used '//
     &                    'instead.'
         else
            write(k,'(a)')' You have chosen the FTP-option.'
         endif
         write(k,*)'The response to your request is stored in file:'
         write(k,*) filename(trimlen(ftpdir)+1:trimlen(filename))
         write(k,*)
         write(k,*)'You may retrieve this file by doing:'
         write(k,*)
         write(k,'(a)')' ftp '//cipnumber(1:trimlen(cipnumber))
         write(k,*)'(login to our computer: username=ftp'//
     &                                        ' password=ftp )'
         write(k,'(a)')' cd '//userftpdir(1:trimlen(userftpdir))
         write(k,*)'get '//filename(trimlen(ftpdir)+1:trimlen(filename))
         write(k,*)'quit'
         write(k,*)
         write(k,*)'NOTE: The file may be deleted after 24 hours!'
      endif
      close(k)
c
      RETURN
      end ! of subr. ftphandler
c
      subroutine HELP(it,helperli)
c
c     This is the new version of subr. pleasehelp, that acts according to the
c     new format GSE2.0 .
c     Find out if the request mail is one where the sender is testing the
c     AutoDRM for the first time and wants some primary information about it
c     This is the case if either the word 'help' appears as subject or in
c     the main body of the mail.
c
      implicit none
      integer it, i
      character line*80
      logical helperli
c
      rewind(it)
      i=0
c
c     First, check if the word 'help' appears as the subject of the mail:
c
 1    read(it,'(a)',end=999) line
      call CASEFOLD(line)
      if(line.ne.' ')then
         if(line(1:8).eq.'SUBJECT:')then
            if(INDEX(line,'HELP').gt.0)then
               helperli=.true.
               RETURN
            endif
         endif
      else
         goto 2 ! blank line -> header is over; read main body of mail
      endif
      goto 1
c
c     Now, check if the word 'help' appears in the main body of the mail:
c
 2    read(it,'(a)',end=999) line
      if(line.eq.' ') goto 2  ! do not count blank lines
      if(line(1:5).eq.'-----') goto 2  ! lines: --- body part 1 ---   etc.
      i=i+1
      call CASEFOLD(line)
      if(INDEX(line,'HELP').gt.0)then
         helperli=.true.
         RETURN
      endif
      if(i.gt.3) goto 999 ! search only first 2-3 lines in the mail
      goto 2
c
 999  continue
      rewind(it)
c
      RETURN
      end ! of subr. help
c
      subroutine MAKEADDRESS(tryemailaddress,emailaddress,
     &                       operatoraddress)
c
c     given the e-mail address in the incoming mail (tryemailaddress), find
c     out how the real e-mail address to be used (emailaddress) looks like
c
      implicit none
      integer k, trimbeg, trimlen
      character*(*) tryemailaddress, emailaddress, operatoraddress
      character string*200
c
      string=tryemailaddress
      tryemailaddress=string(trimbeg(tryemailaddress):)
c
c  Next address-type must be checked FIRST (before the one with parantheses!)
c
c  Address of the type:
c  From: Urs Kradolfer <KRADOLFER@ifg.ethz.ch>
c
c Anmerkung vom 3.6.92: offensichtlich ist `mailx' in der Lage, eine adresse
c              vom typ: /S=seizmoloski-zavod/O=uni-lj/PRMD=ac/@NOPRMD.mail.yu
c              zu verstehen und abzuschicken!!!
c
      k=INDEX(tryemailaddress,'<')
      if(k.gt.0)then
         string=tryemailaddress
         tryemailaddress=string(k+1:)
         k=INDEX(tryemailaddress,'>')
         if(k.gt.0)then
            string=tryemailaddress
            tryemailaddress=string(1:k-1)
         else
            tryemailaddress=' '  ! should never occur!!
         endif 
         if(tryemailaddress(1:13).eq.'MAILER-DAEMON')
     &                               tryemailaddress=operatoraddress
         if(tryemailaddress(1:13).eq.'Mailer-Daemon')
     &                               tryemailaddress=operatoraddress
         if(tryemailaddress(1:13).eq.'Mailer-daemon')
     &                               tryemailaddress=operatoraddress
         goto 777
      endif
c
c  Address of the type:
c  From: kradi (Urs Kradolfer)
c
      k=INDEX(tryemailaddress,'(')
      if(k.gt.0)then
         tryemailaddress(k:)=' '
         goto 777
      endif
c
c  Address of the type:
c  From: "PSI%TELEPAC.024037153022::CHE"@JANUS.vmsmail.ethz.ch
c
      if(tryemailaddress(1:5).eq.'"PSI%')then
         string=tryemailaddress
         tryemailaddress=string(2:)
         k=INDEX(tryemailaddress,'"')
         if(k.gt.0)then
            string=tryemailaddress
            tryemailaddress=string(1:k-1)
         else
            tryemailaddress=' '  ! should never occur!!
         endif
         k=INDEX(tryemailaddress,'TELEPAC.')
         if(k.gt.0)then
            string=tryemailaddress
            tryemailaddress=string(1:k-1)//string(k+8:)
         endif
         goto 777
      endif
c
c  Address of the type:
c  From: "JANUS::KRADI"@JANUS.vmsmail.ethz.ch
c
      if(tryemailaddress(1:1).eq.'"')then
         string=tryemailaddress
         tryemailaddress='\"'//string(2:trimlen(string))
         k=INDEX(tryemailaddress(3:),'"') ! 3 because SECOND " should be found !
         if(k.gt.0)then
            string=tryemailaddress
            tryemailaddress=string(1:k+1)//
     &                        '\"'//string(k+3:trimlen(string))
         else
            tryemailaddress=' '  ! should never occur!!
         endif
         goto 777
      endif
c
c
 777  continue
      emailaddress=tryemailaddress
      tryemailaddress=' '
c
      RETURN
      end ! of subr. makeaddress
c
      subroutine WRITEHELP(is,emailaddress,operatoraddress,
     &                     autodrmemailaddress)
c
c     if the sender has sent a mail with the string 'help' then
c     send some basic information on how to request a user's guide
c
      implicit none
      integer is, trimlen
      character*(*) emailaddress, operatoraddress, autodrmemailaddress
c
      write(is,*)
      write(is,'(a)')'DATA_TYPE comment'
      write(is,*)
      write(is,'(a)')' If you wish to receive a detailed User`s Guide'//
     &           ' please send a request'
      write(is,'(a)')' mail to the AutoDRM. The e-mail address is:'
      write(is,*)
cuk2001      write(is,'(a)')'   AUTODRM@SEISMO.IFG.ETHZ.CH'
      write(is,'(a,a)')'   ',
     &               autodrmemailaddress(1:trimlen(autodrmemailaddress))
      write(is,*)
      write(is,'(a)')' Your request mail should look as follows:'
      write(is,*)
      write(is,'(a)')' BEGIN'
      write(is,'(a)')' GUIDE'
      write(is,'(a,a)')' EMAIL ',emailaddress(1:trimlen(emailaddress))
      write(is,'(a)')' STOP'
      write(is,*)
      write(is,'(a)')' Note: The string after the command EMAIL '//
     &               '(see above)'
      write(is,'(a)')' ----  is the return address you should use!'
      write(is,'(a)')
      write(is,'(a)')'       All commands must be LEFT-JUSTFIED!'
      write(is,'(a)')'       (i.e. commands must start on column 1)'
      write(is,'(a)')
      write(is,'(a)')' If everything fails, send an e-mail to:'
      write(is,'(a,a)')'   ',operatoraddress(1:trimlen(operatoraddress))
      write(is,*)
      write(is,'(a)')' GOOD LUCK - and enjoy our AutoDRM !'
      write(is,*)
c
      RETURN
      end ! of subr. writehelp
c
      subroutine USERTYPE(superuserfile,useraddress,superuser)
c
c     find out if the sender of the request is a 'super-user' (i.e. he
c     may retrieve more and larger amounts of data than others)
c
      implicit none
      integer iu
      character*(*) superuserfile, useraddress
      character line*80
      logical superuser
c
      superuser=.false.
      call CASEFOLD(useraddress)
c
      call FREEUNIT(iu)
      open(iu,file=superuserfile,status='old',err=998)
   1  read(iu,'(a)',end=999) line
      call CASEFOLD(line)
      if(useraddress.eq.line)then
         superuser=.true.
         close(iu)
         RETURN
      endif
      goto 1
c
 998  RETURN
c
 999  close(iu)
      RETURN
c
      end ! of subr. usertype
c
      subroutine INIT(observatoryname,sourceid,mailprogram,helpfile,
     &                superuserfile,codecoprog,logfile,ftpdir,
     &                userftpdir,operatoraddress,cipnumber,sysnam,
     &                maxfilesize,allowfile,denyfile,
     &                autodrmemailaddress,
     &                spamheadfile,spambodyfile)
c
c     initaliaze some variables by reading the file autodrm.rc
c
      implicit none
      integer i, k, trimlen, maxfilesize
      character*(*) mailprogram,helpfile,superuserfile, userftpdir,
     &              codecoprog,logfile,ftpdir,operatoraddress,
     &              allowfile, denyfile, autodrmemailaddress,
     &              spamheadfile,spambodyfile
      character*7 sourceid
      character*80 rcfile, line, inpline(8), observatoryname
      character cipnumber*50, homedir*100, sysnam*10
c
c     See, where the where the rc-file (for initialization) is:
c
      call GETHOMEDIR(homedir)
      rcfile=homedir(1:trimlen(homedir))//'/adm/autodrm.rc'
c
      call GETSYSTEM(sysnam)
      mailprogram=' '
      if(sysnam.eq.'HP-UX') mailprogram='mailx'
      if(sysnam.eq.'SunOS') mailprogram='mail'
      if(sysnam.eq.'Solaris') mailprogram='mailx'
      if(sysnam.eq.'AIX') mailprogram='mailx'
      if(sysnam.eq.'OSF1') mailprogram='mailx'
      if(sysnam.eq.'Linux') mailprogram='mailx'
      if(mailprogram.eq.' ') STOP'subr. INIT>>> no mailprogram defined!'
      helpfile=homedir(1:trimlen(homedir))//'/adm/autodrm.help'
      superuserfile=homedir(1:trimlen(homedir))//'/adm/autodrm.super'
      codecoprog=homedir(1:trimlen(homedir))//'/res/codeco.f'
      logfile=homedir(1:trimlen(homedir))//'/log/autodrm_users.log'
      allowfile=homedir(1:trimlen(homedir))//'/adm/autodrm.allow'
      denyfile=homedir(1:trimlen(homedir))//'/adm/autodrm.deny'
      spamheadfile=homedir(1:trimlen(homedir))//'/adm/spam.head'
      spambodyfile=homedir(1:trimlen(homedir))//'/adm/spam.body'
c
      call FREEUNIT(i)
      open(i,file=rcfile,status='unknown')
      k=0
   1  read(i,'(a)',end=888) line
      if(line(1:1).eq.'#'.or.line(1:1).eq.'*') goto 1
      k=k+1
      inpline(k)=line
      goto 1
c
 888  close(i)
      if(k.lt.8) stop'INIT>>> autodrm.rc file too short!'
      if(k.gt.8) stop'INIT>>> autodrm.rc file too long!'
      observatoryname=inpline(1)
      sourceid=inpline(2)
      cipnumber=inpline(3)
      ftpdir=inpline(4)
      userftpdir=inpline(5)
      i=trimlen(ftpdir)
      ftpdir(i+1:i+1)='/'     ! UNIX operating system
      read(inpline(6),*,err=999,end=999) maxfilesize
      autodrmemailaddress=inpline(7)
      operatoraddress=inpline(8)
c
      RETURN
c
 999  stop'INIT>>> error reading maxfilesize!'
c
      end ! of subr. init
c
      integer function TRIMLEN(t)   ! Urs Kradolfer, June 1986
c
c     Call:    nc=TRIMLEN(char)
c
c          --> nc says, how many characters the input-string has
c              (ignoring trailing blanks!).
c
      implicit none
      character t*(*)
      do 1 trimlen=LEN(t),1,-1
    1    if(t(trimlen:trimlen).ne.' ')RETURN
      trimlen=1
      end ! of integer function trimlen
c
      integer function TRIMBEG(t)   ! Urs Kradolfer, 17.1.90
c
c     Call:    nc=TRIMBEG(char)
c
c          --> nc returns the position of the first characters of 
c              the input-string (ignoring leading blanks!).
c
      implicit none
      character t*(*)
      do 1 trimbeg=1,LEN(t)
    1    if(t(trimbeg:trimbeg).ne.' ')RETURN
      trimbeg=1
      end ! of integer function trimbeg
c
      subroutine FREEUNIT(iunit)
c
c     get a free fortran file-unit number that is not yet in use
c
      implicit none
c
c     Purpose: Get a free FORTRAN-unit
c
c     Output: iunit  a free (file-)unit number
c
c     Urs Kradolfer, 16.7.90
c
      integer iunit
      logical lopen
c
      do iunit=10,999
         if(iunit.eq.999) stop'FREEUNIT>>> no free unit found!'
         inquire(unit=iunit,opened=lopen)
         if(.not.lopen) RETURN
      enddo
c
      RETURN
c
      end ! of subr. freeunit
c
      subroutine FREEFILE(filename)
c
c     get a unique file name
c
      implicit none
c
c     Purpose: get a unique filename
c
c     Input:  A trial filename
c     Output: A unique filename, starting with the trial filename
c
c     Urs Kradolfer, 16.7.90
c
      integer i, trimbeg,trimlen, i1,i2
      character*(*) filename
      character*100 testfilename, startfilename, string
      logical lexist
c
      i=0
ccc OSF1 does not like this      if(filename.eq.' '.or.filename.eq.'')then
      if(filename.eq.' ')then
         startfilename='freefile'
      else
         startfilename=filename
      endif
      testfilename=startfilename
 1    inquire(file=testfilename,exist=lexist)
      if(.not.lexist)then
          filename=testfilename
          goto 888 ! RETURN
      else
         i=i+1
         write(string,*) i
         i1=trimbeg(string)
         i2=trimlen(string)
         testfilename=startfilename(1:trimlen(startfilename))//
     &                string(i1:i2)
         goto 1
      endif
c
 888  RETURN
c
      end ! of subr. freefile
c
      subroutine CASEFOLD(cn) ! Urs Kradolfer, 20. Feb. 1990
c
c     put all characters of the inout string into UPPER CASE letters
c
c
c Input : character-string of any length
c Output: same character-string, but all letters are CAPITAL now
c         (other characters are not changed)
c
c   --> this subr. needs the function TRIMLEN !
c
c Call  : call CASEFOLD(charstring)
c
      implicit none
      character cn*(*)
      integer i, trimlen,ilen, ival
      ilen=trimlen(cn)
      do i=1,ilen
         ival=ICHAR(cn(i:i))
         if(ival.ge.97.and.ival.le.122)then
            cn(i:i)=CHAR(ival-32)
         endif
      enddo
      RETURN
      end ! of subr. casefold
c
      subroutine NUMDATETIME(cdate,iyr,imo,iday,ihr,min,sec)
c     Urs Kradolfer, 19.3.91
c
c     Purpose: Convert the date and time obtained by this routine
c              DATETIME into numerical values
c
c     Call   : call NUMDATETIME(cdate,iyr,imo,iday,ihr,min,sec)
c
      implicit none
      integer iyr,imo,iday,ihr,min
      real sec
      character*(*) cdate
      character cmo*3
c
      read(cdate(5:6),*) iday
      read(cdate(8:9),*) ihr
      read(cdate(11:12),*) min
      read(cdate(14:15),*) sec
      read(cdate(17:20),*) iyr
      cmo=cdate(1:3)
      if(cmo.eq.'Jan')then
         imo=1
         RETURN
      endif 
      if(cmo.eq.'Feb')then
         imo=2
         RETURN
      endif 
      if(cmo.eq.'Mar')then
         imo=3
         RETURN
      endif 
      if(cmo.eq.'Apr')then
         imo=4
         RETURN
      endif 
      if(cmo.eq.'May')then
         imo=5
         RETURN
      endif 
      if(cmo.eq.'Jun')then
         imo=6
         RETURN
      endif 
      if(cmo.eq.'Jul')then
         imo=7
         RETURN
      endif 
      if(cmo.eq.'Aug')then
         imo=8
         RETURN
      endif 
      if(cmo.eq.'Sep')then
         imo=9
         RETURN
      endif 
      if(cmo.eq.'Oct')then
         imo=10
         RETURN
      endif 
      if(cmo.eq.'Nov')then
         imo=11
         RETURN
      endif 
      if(cmo.eq.'Dec')then
         imo=12
         RETURN
      endif 
c
      end ! of subr. numdatetime 
c
      subroutine MAILTEST(line,cdate)
c
c     Urs Kradolfer, 26.9.91
c
c     Input:   a character string (e.g. a line of a mail file)
c     Output:  if the line is the first line of a mail header, the
c              receiving date of the mail is returned, otherwise
c              a blank string is returned
c
c     This routine has been tested on the following operating systems:
c     HP-UX, SunOS, ULTRIX
c
      implicit none
      integer trimlen, i, k, iword, j
      character*(*) line, cdate
      character string*200
      logical newword
c
      cdate=' '
      string=line
      if(string(1:5).ne.'From ') RETURN
      string=string(6:)
      iword=0
      newword=.false.
      k=trimlen(string)
      if(k.lt.20) RETURN
      do i=1,k
         if(string(i:i).eq.' ')then
            newword=.false.
         else
            if(.not.newword)then
               iword=iword+1 
               newword=.true.
               if(iword.eq.5)then
                  j=INDEX(string(i:i+2),':')
                  if(j.le.0) RETURN  ! ULTRIX wants a colon in the 5th word
               endif
               if(iword.eq.8) RETURN  ! ULTRIX accepts only 6 or 7 'words'
            endif
         endif
      enddo
c
999   continue
      if(iword.eq.6.or.iword.eq.7)then
         if(string(k-4:k-4).eq.' '.and.string(k-8:k-8).eq.' ')then
            string=string(:k-8)//string(k-3:k)
            k=trimlen(string)
         endif
         cdate=string(k-19:k)
         string=cdate
         if(cdate(10:10).ne.':')then
            cdate=string(4:16)//'   '//string(17:20)
         endif
      endif
c
      RETURN
      end ! of subr. mailtest
c
      subroutine CHECKNOFORWARD(it,noforward)
c
c     find out if the request mail is a response mail from the AutoDRM:
c
      implicit none
      integer it
      character line*80
      logical noforward
c
 1    read(it,'(a)',end=999) line
      call CASEFOLD(line)
      if(INDEX(line,'### Below follows the request ').gt.0)then
         noforward=.true.
         goto 999
      endif
      if(INDEX(line,'### Recognized the string PLEASE HELP ').gt.0)then
         noforward=.true.
         goto 999
      endif
      if(INDEX(line,'### Recognized the string HELP ').gt.0)then
         noforward=.true.
         goto 999
      endif
      goto 1
c
 999  continue
      rewind(it)
c
      RETURN
      end ! of subr. checknoforward
c
      subroutine GETHOMEDIR(homedir)       ! Urs Kradolfer, 27.4.94
c
c     return UNIX-HOME-directory
c
c     Call:    call GETHOMEDIR(homedir)
c
c     returned value: HOME-directory of thew user running this program
c                     (output of the UNIX-command: echo $HOME )
c
      implicit none
      integer iu, trimlen, k
      character homedir*(*), string*200, file*80
c
      call FREEUNIT(iu)
      file='homedir.name'
      call FREEFILE(file)
      string='echo $HOME > '//file
      call system(string)
c
      open(iu,file=file,status='old')
      read(iu,'(a)') homedir
      close(iu)
      string='/bin/rm -f '//file
      call system(string)
c
      k=trimlen(homedir)
      if(k.gt.LEN(homedir))then
         stop'GETHOMEDIR>>> dimension of variable homedir too small!'
      endif
c
      RETURN
c
      end ! of subr. gethomedir
c
      subroutine GETSYSTEM(systemname)
c
c     Urs Kradolfer, 27.4.94, Version of 27.4.95
c
c     return UNIX-operating-system-type
c
c     Works on HP-UX, SunOS and Solaris
c
c     Call:    call GETSYSTEM(systemname)
c
c     returned value: Name of Operating System, where program is running
c                     (output of the UNIX-command: uname -s )
c                 and (output of the UNIX-command: uname -r )
c
c     Variable systemname must be declared in the calling program unit as
c     a character with minimum length 10 ( character systemname*10 )
c
      implicit none
      integer iu, trimlen, k, iversion
      character systemname*(*), string*200, file*80
c
      call FREEUNIT(iu)
      file='system.name'
      call FREEFILE(file)
      string='uname -s > '//file
      call system(string)
c
      open(iu,file=file,status='old')
      read(iu,'(a)') systemname
      close(iu)
      string='/bin/rm -f '//file
      call system(string)
c
      if(systemname.eq.'SunOS')then ! check out, if it's Solaris or not...
         string='uname -r | cut -d"." -f 1 > '//file
         call system(string)
         open(iu,file=file,status='old')
         read(iu,*) iversion
         close(iu)
         string='/bin/rm -f '//file
         call system(string)
         if(iversion.ge.5) systemname='Solaris'
      endif
c
      k=trimlen(systemname)
      if(k.gt.LEN(systemname))then
         stop'GETSYSTEM>>> dimension of variable systemname too small!'
      endif
c
      RETURN
c
      end ! of subr. getsystem
c
      subroutine DATETIME(cdate)       ! Urs Kradolfer, 5.11.91
c
c     File:    datetime_hpux.f
c
c     return UNIX-date and time (local time)
c
c     This modified version (13.4.94) should run on all unix-machines
c                                     and in all time zones!
c
c     Call:    call DATETIME(cdate)
c
c     returned value: cdate  is a character*20
c
c     the old version (file datetime_hpux.f_old) used C-calls, but since
c     HP-UX revision 8.0 the routine did not work anymore (it DOES run in
c     small programs, but not in other ones as the autodrm...)
c
      implicit none
      integer iu, trimlen, k
      character cdate*20, datum*40, string*200, file*80
c
      call FREEUNIT(iu)
      file='dateand.time'
      call FREEFILE(file)
      string='date > '//file
      call system(string)
c
c     System returns 'datum' in the form:
c
c     Tue Nov  5 21:10:11 MEZ 1991            or:
c     Mon Mar 30 17:25:13 MESZ 1992           or:
c     Sun Apr  3 00:02:37 METDST 1994
c
      open(iu,file=file,status='old')
      read(iu,'(a)') datum
      close(iu)
      string='/bin/rm -f '//file
      call system(string)
c
      cdate='12345678901234567890'
      string=datum(5:20)
cc      if(datum(21:24).eq.'MEZ ') cdate=string(1:16)//datum(25:28)  
cc      if(datum(21:24).eq.'MESZ') cdate=string(1:16)//datum(26:29)  
cc      if(datum(17:22).eq.'METDST') cdate=string(1:16)//datum(28:31)  
cc      if(datum(17:24).eq.'GMT+0100') cdate=string(1:16)//datum(30:33)  
cc      if(datum(17:24).eq.'GMT+0200') cdate=string(1:16)//datum(30:33)  
      k=trimlen(datum)
      if((k-3).gt.0) cdate=string(1:16)//datum(k-3:k)
c
c     This routine returns 'cdate' in the form:
c
c     Nov  5 21:10:11 1991
c
      RETURN
c
      end ! of subr. datetime
c
      subroutine DATETIMEUTC(cdate)       ! Urs Kradolfer, 21.21.92
c
c     File:    datetimeutc.f
c
c     return UNIX-date and time in UTC (GMT)
c
c     This modified version (13.4.94) should run on all unix-machines
c                                     and in all time zones!
c
c     Call:    call DATETIMEUTC(cdate)
c
c     returned value: cdate  is a character*20
c
c     the old version (file datetime_hpux.f_old) used C-calls, but since
c     HP-UX revision 8.0 the routine did not work anymore (it DOES run in
c     small programs, but not in other ones as the autodrm...)
c
      implicit none
      integer iu, trimlen, k
      character cdate*20, datum*40, string*200, file*80
c
      call FREEUNIT(iu)
      file='dateand.time'
      call FREEFILE(file)
      string='date -u > '//file
      call system(string)
c
c     System returns 'datum' in the form:
c
c     Tue Nov  5 21:10:11 UTC 1991             or:
c     Tue Nov  5 21:10:11 GMT 1991 
c
      open(iu,file=file,status='old')
      read(iu,'(a)') datum
      close(iu)
      string='/bin/rm -f '//file
      call system(string)
c
      cdate='12345678901234567890'
      string=datum(5:20)
cc      if(datum(21:24).eq.'UTC ') cdate=string(1:16)//datum(25:28)  
      k=trimlen(datum)
      if((k-3).gt.0) cdate=string(1:16)//datum(k-3:k)
c
c     This routine returns 'cdate' in the form:
c
c     Nov  5 21:10:11 1991
c
      RETURN
c
      end ! of subr. datetimeutc
c
      subroutine GETFILESIZE(file,sizefile,ibytes)
c
c     Urs Kradolfer, 18.4.91, Version of 27.4.95
c
c     File: getfilesize.f
c
c     RUNS ON HP-UX, SunOS, and Solaris OPERATING SYSTEMS
c
c     Purpose:  get the size of a file (in bytes)
c
c     Call:    call GETFILESIZE(file,sizefile,ibytes)
c
c     Input : file       file of which the size should be determined
c             sizefile   filename for temporary file
c                        (this file will be unique and removed on return
c                        by the command:  /bin/rm -f sizefile  )
c
c     Output: ibytes     filesize in bytes
c                        ibytes set to -1 if file not found!
c
      implicit none
      integer ibytes, isi, trimlen
      character*(*) file, sizefile
c95      character*200 string, sizefile1, sysnam*5
      character*200 string, sizefile1
c
      ibytes=-1
      call FREEUNIT(isi)
      sizefile1=sizefile
      call FREEFILE(sizefile1)
c95      string='\ls -l '//file(1:trimlen(file))//
c97      string='/bin/ls -lo '//file(1:trimlen(file))//
c97     &       ' > '//sizefile1    ! because of Sun only one '>' is allowed!
      string='/bin/ls -l '//file(1:trimlen(file))//
     &       " | awk '{print $5}' > "//sizefile1
      call system(string)
      open(isi,file=sizefile1,status='old')
      string=' '
      read(isi,'(a)',end=999,err=999) string
 999  continue
      close(isi)
      if(string.ne.' ')then
c95         call GETSYSTEM(sysnam)
c95         if(sysnam.eq.'HP-UX') read(string(33:40),*) ibytes   ! on HP-UX
c95         if(sysnam.eq.'SunOS') read(string(24:31),*) ibytes   ! on SunOS
c97         read(string(24:32),*) ibytes
         read(string,*,err=1000) ibytes
      else
         ibytes=-1
      endif
 1000 continue
      string='/bin/rm -f '//sizefile1(1:trimlen(sizefile1))
      call system(string)
c
      RETURN
      end ! of subr. getfilesize
c
      subroutine CHECKforDIFFERENTmail(it,creceivedate,badsender)
c
c     If within the same (absolute) 10 minutes the same requestor sends
c     the same request mail, ignore the request (could be an infinite loop)!
c
      implicit none
      integer it, inl, trimlen, ibytes
      character homedir*80, lastrequestfile*80, line*80,
     &          newlrfile*80, string*300, diffile*80, badsender*80,
     &          creceivedate*20, sender*80
c
      badsender=' '
c
      rewind(it)
c
      call GETHOMEDIR(homedir)
      lastrequestfile=homedir(1:trimlen(homedir))//'/log/last.request'
      newlrfile=lastrequestfile(1:trimlen(lastrequestfile))//'.1'
      call FREEUNIT(inl)
      open(inl,file=newlrfile,status='unknown')
c
c     store date/time (down to a precision of 10 minutes) when sender's
c     request arrived:
c     (string 'creceivedate' has the format: May 30 10:18...
c     so the first 11 characters are:        May 30 10:1        )
c
      write(inl,'(a)') creceivedate(1:11)
c
c     read until main-body of the mail and store sender's address:
c
      sender=' '
 1    read(it,'(a)',end=999) line
      if(line(1:5).eq.'From:')then
         sender=line(7:)
         write(inl,'(a)') line(1:trimlen(line))
      endif
      if(line.ne.' ') goto 1 ! first blank line means 'end-of-mail-header'
c
c     now store main body of the mail:
c
 2    read(it,'(a)',end=3) line
      write(inl,'(a)') line(1:trimlen(line))
      goto 2
 3    close(inl)
c
c     Check, if address and mail-body of this request is the same as for the
c     last request:
c
      diffile='diff.file'
      call FILES(diffile,'new')
      string='diff '//newlrfile(1:trimlen(newlrfile))//' '//
     &       lastrequestfile(1:trimlen(lastrequestfile))//
     &       ' > '//diffile(1:trimlen(diffile))
      call system(string)
      call GETFILESIZE(diffile,'size.fil',ibytes)
      if(ibytes.le.0)then
         badsender=sender
         if(badsender.eq.'IDC testbed operations <testbed@cmr.gov>')then
            badsender=' ' ! send it anyway... these guys often send duplicates
         endif
      else
         badsender=' '
      endif
c
 999  close(inl)
c
c     Now move ('rename') relevant part of this mail to last.request file:
c
      string='/bin/mv -f '//newlrfile(1:trimlen(newlrfile))//' '//
     &       lastrequestfile(1:trimlen(lastrequestfile))
      call system(string)
c
      RETURN
      end ! of subr. checkfordifferentmail
c
      subroutine MAKEMSGID(msgid,sourceid)
      implicit none
      integer k
      character msgid*30, sourceid*7
c
      call DATETIMEUTC(msgid)
      msgid(21:)=' '
      do k=1,20
         if(msgid(k:k).eq.' ') msgid(k:k)='_'
      enddo
      msgid(21:)=' '//sourceid
c
      RETURN
      end ! of subr. makemsgid
c
      subroutine GETMSGID(it,msgid,reflin)
      implicit none
      integer it, trimbeg,trimlen, i
      character msgid*30, line*80, reflin*80
c
      rewind(it)
      msgid='(No_MSG_ID_received)'
      i=0
c
   1  read(it,'(a)',end=999,err=999) line
c2000      if(line.ne.' ') goto 1              ! read until end of mail-header
      call CASEFOLD(line)
      if(line(1:5).ne.'BEGIN') goto 1          ! read until start of message
c
   2  read(it,'(a)',end=999,err=999) line
      i=i+1
      call CASEFOLD(line)
      if(line(1:6).eq.'MSG_ID')then
         reflin=line
         line(1:6)=' '
         msgid=line(trimbeg(line):trimlen(line))
         RETURN
      endif
      if(i.gt.5) goto 999 ! search only in the first 5-6 lines for MSG_ID
      goto 2
c
 999  continue
      reflin=' '
      rewind(it)
c
      RETURN
      end ! of subr. getmsgid
c
      subroutine SENDCODECO(is,codecoprog)
      implicit none
      integer is, ii, trimlen
      character line*80
      character*(*) codecoprog
c
      call FREEUNIT(ii)
c
      open(ii,file=codecoprog,status='old')
c
      write(is,'(a)')'DATA_TYPE log'
      write(is,*)
      write(is,'(a)')'### Below follows the requested source '//
     &           'code of program CODECO:'
      write(is,*)
c
  1   read(ii,'(a)',end=999,err=999)  line
      write(is,'(a)') line(1:trimlen(line))
      goto 1
c
 999  close(ii)
      RETURN
c
      end ! of subr. sendcodeco
c
      subroutine COUNTLINES(i,filename,ilin)
      implicit none
      integer i, ilin
      character*(*) filename
      character c*1
c
      ilin=0
      open(i,file=filename,status='unknown')
 1    read(i,'(a)',err=999,end=999) c    ! c added for sun...
      ilin=ilin+1
      goto 1
c
 999  close(i)
c
      RETURN
      end ! of subr. countlines
c
      subroutine CONVTIME(taskline,cdat1,sec1,cdat2,sec2)
c
c     Decode TIME-specification (GSE2.0 format).
c     Minimum requirement is the StartYear!
c     Default for month and day is 1, for hour, minute and second 0.
c     If EndTime is not given, the current time is assumed.
c
      implicit none
      integer iyr1,iyr2,imo1,imo2,idy1,idy2,ihr1,ihr2,imn1,imn2,
     &        i, trimbeg, itime
      real sec1,sec2
      character*(*) taskline, cdat1,cdat2
      character*1024 string, string1,string2, dat,tim
      character cdate*20
      logical doreturn
c
      string=' '
      string1=' '
      string2=' '
      iyr1=0
      imo1=0
      idy1=0
      ihr1=0
      imn1=0
      sec1=0.0 
      iyr2=0
      imo2=0
      idy2=0
      ihr2=0
      imn2=0
      sec2=0.0 
c
      string=taskline(5:)  ! strip off 'TIME' string
      if(string.eq.' ')then
         cdat1='error'
         RETURN
      endif
c
      i=INDEX(string,'TO')
      if(i.gt.0)then
         if(i.gt.1)then
            string1=string(1:i-1)
         else
            cdat1='error'
            RETURN
         endif
         string2=string(i+2:)
      else
         string1=string
      endif
      if(string1.eq.' ')then
         cdat1='error'
         RETURN
      endif
c
      call SPLITSTRING(string1,dat,tim,' ')
      tim=tim(trimbeg(tim):)
      call SUBSTCHARS(dat,'/',' ')
      read(dat,*,err=1,end=1) iyr1,imo1,idy1
  1   read(dat,*,err=2,end=2) iyr1,imo1
  2   read(dat,*,err=3,end=3) iyr1
  3   continue
      call SUBSTCHARS(tim,':',' ')
      read(tim,*,err=4,end=4) ihr1,imn1,sec1
  4   read(tim,*,err=5,end=5) ihr1,imn1
  5   read(tim,*,err=6,end=6) ihr1
  6   continue
      if(string2.ne.' ')then
         call SPLITSTRING(string2,dat,tim,' ')
         call SUBSTCHARS(dat,'/',' ')
         read(dat,*,err=11,end=11) iyr2,imo2,idy2
 11      read(dat,*,err=12,end=12) iyr2,imo2
 12      read(dat,*,err=13,end=13) iyr2
 13      continue
         call SUBSTCHARS(tim,':',' ')
         read(tim,*,err=14,end=14) ihr2,imn2,sec2
 14      read(tim,*,err=15,end=15) ihr2,imn2
 15      read(tim,*,err=16,end=16) ihr2
 16      continue
      else
         call DATETIMEUTC(cdate)
         call NUMDATETIME(cdate,iyr2,imo2,idy2,ihr2,imn2,sec2)
      endif
c
      doreturn=.false.
      if(iyr1.le.1000) doreturn=.true.    ! one could request historic data...
      if(iyr1.gt.2050) doreturn=.true.    ! must be changed in the year 2050...
      if(iyr2.le.1000) doreturn=.true.
      if(iyr2.gt.2050) doreturn=.true.
      if(imo1.le.0) doreturn=.true.
      if(imo1.gt.12) doreturn=.true.
      if(imo2.le.0) doreturn=.true.
      if(imo2.gt.12) doreturn=.true.
      if(idy1.le.0) doreturn=.true.
      if(idy1.gt.31) doreturn=.true.
      if(idy2.le.0) doreturn=.true.
      if(idy2.gt.31) doreturn=.true.
      if(ihr1.lt.0) doreturn=.true.
      if(ihr1.gt.24) doreturn=.true.
      if(ihr2.lt.0) doreturn=.true.
      if(ihr2.gt.24) doreturn=.true.
      if(imn1.lt.0) doreturn=.true.
      if(imn1.gt.60) doreturn=.true.
      if(imn2.lt.0) doreturn=.true.
      if(imn2.gt.60) doreturn=.true.
      if(sec1.lt.0.0) doreturn=.true.
      if(sec1.gt.100.0) doreturn=.true.   ! could also be 200 or so...
      if(sec2.lt.0.0) doreturn=.true.
      if(sec2.gt.100.0) doreturn=.true.   ! could also be 200 or so...
      if(doreturn)then
         cdat1='error'    ! format error in date/time
         RETURN
      endif
c
      call TIMECLEAR(iyr1,imo1,idy1,ihr1,imn1,sec1,itime)
      call TIMECLEAR(iyr2,imo2,idy2,ihr2,imn2,sec2,itime)
c
      write(cdat1,'(i4.4,4i2.2)',err=999) iyr1,imo1,idy1,ihr1,imn1
      write(cdat2,'(i4.4,4i2.2)',err=999) iyr2,imo2,idy2,ihr2,imn2
      if(INDEX(cdat1,'*').gt.0.or.iyr1.lt.1000)then ! 2nd check for Y2K problem
         cdat1='error'    ! format error in date/time
         RETURN
      endif
      if(INDEX(cdat2,'*').gt.0.or.iyr2.lt.1000)then ! 2nd check for Y2K problem
         cdat2='error'    ! format error in date/time
         RETURN
      endif
c
      RETURN
c
c     come here, if a read/write-error occurred
c
 999  cdat1='error'
      RETURN
c
      end ! of subr. convtime
c
      subroutine splitstring(str1,str2,str3,c)
c
c       Manfred Baer 10.7.1990
c       slightly modified for kradi's trimlen routine 27.9.91
c
c       !!! str2 and str3 must be equally dimensioned as str1 !!!
c
c       modification suggested by Donat Faeh (see 'cdf') / 18.3.96
c       --> In this case, str2 may be dimensioned smaller than str1 and str3 !
c       (in particular, str2 may be dimensioned exactly as expected!)
c
c       Input:  str1   string
c               c      delimeter string (may be several characters long)
c       Output: str2   first 'word' (no leading blanks) before delimeter
c               str3   rest of str1 after and without delimeter
c
      implicit none
      character*(*) str1,str2,str3,c
      integer*2 i,k,k1,k2,k3
      integer trimlen
c
      k1= trimlen(str1)
      if(k1.le.0) then
         str2=' '
         str3=' '
         return
      endif
      k2= len(str2)
      k3= max(1,trimlen(c))
      do i=1,k1
         if(str1(i:i).ne.' ') goto 10
      end do
 10   k= i
      str3= str1(k:k1)
      str1= str3
      k1= k1-k+1
      i= index(str1,c(1:k3))
      str2= str1
      if(i.le.0) then
         str3= ' '
         return
      endif
      if(i.le.k2) str2(i:)= ' '      ! cdf
cdf      str2(i:)= ' '
      if(i+k3.le.k1) then 
         str3= str1(i+k3:k1)
      else
         str3= ' '
      endif
      return
      end ! of subr. splitstring
c
      subroutine CHECKCDAT(cdat1,sec1,cdat2,sec2,il,ie,gseformat,
     &                     ideltamin,resultok)
      implicit none
      integer il,ie, minutes1,minutes2, ideltamin, juliam2, minutesc,
     &        iyr1,imo1,idy1,ihr1,imn1,
     &        iyr2,imo2,idy2,ihr2,imn2,
     &        iyrc,imoc,idyc,ihrc,imnc
      real secc, sec1,sec2
      character cdat1*12,cdat2*12, cdate*20, gseformat*10
      logical resultok
c
      resultok=.false.
      ideltamin=0
c
c     Calculate current time:
c
      call DATETIMEUTC(cdate)
      call NUMDATETIME(cdate,iyrc,imoc,idyc,ihrc,imnc,secc)
      minutesc=JULIAM2(iyrc,imoc,idyc,ihrc,imnc)
c
c     Check StartDateTime:
c
      if(cdat1.eq.' ')then
         if(gseformat.eq.'GSE2.0')then
            write(il,'(a)')' StartDateTime not defined'
         else
            write(ie,'(a)')'*** DATE1 is missing!'
            write(ie,'(a)')'*** Most commands   m u s t   '
            write(ie,'(a)')'*** be preceeded by the '//
     &                          'DATE1 and DATE2 commands!'
         endif
         RETURN
      endif
c
      read(cdat1,'(i4,4i2)',err=998,end=998) iyr1,imo1,idy1,
     &                                       ihr1,imn1
      if(imo1.lt.1.or.imo1.gt.12.or.idy1.lt.1.or.idy1.gt.31
     &                          .or.ihr1.lt.0.or.ihr1.gt.23
     &                          .or.imn1.lt.0.or.imn1.gt.59)then
         if(gseformat.eq.'GSE2.0')then
            write(ie,'(a)')' Error in StartTime'
         else
            write(ie,'(a)')'*** error: specification of DATE1'//
     &                     ' is not correct!'
            write(ie,'(a)')'*** DATE1 must be of the form'//
     &                     ' YYYYMMDDHHMM !'
         endif
         RETURN
      endif
c
      minutes1=JULIAM2(iyr1,imo1,idy1,ihr1,imn1)
      if(minutes1.gt.minutesc)then
         if(gseformat.eq.'GSE2.0')then
            write(ie,'(a)')' Error: StartTime is *after* CurrentTime'
         else
            write(ie,'(a)')'*** error: DATE1 is AFTER current date!'
         endif
         RETURN
      endif
c
c     Check EndtDateTime:
c
      if(cdat2.eq.' ')then
         if(gseformat.eq.'GSE2.0')then
            write(il,'(a)')' Warning: EndDateTime is not'//
     &                              'defined'
            write(il,'(a)')' -------> Setting EndTime to CurrentTime'
            write(il,'(a)')'          (Hope, this is o.k. for you)'
         else
            write(ie,'(a)')'*** warning: DATE2 not defined'
            write(ie,'(a)')'*** -------> Setting DATE2 to '//
     &                                  'current date.'
         endif
         minutes2=minutesc
         sec2=secc
      endif
c
      read(cdat2,'(i4,4i2)',err=998,end=998) iyr2,imo2,idy2,
     &                                       ihr2,imn2
      if(imo2.lt.1.or.imo2.gt.12.or.idy2.lt.1.or.idy2.gt.31
     &                          .or.ihr2.lt.0.or.ihr2.gt.23
     &                          .or.imn2.lt.0.or.imn2.gt.59)then
         if(gseformat.eq.'GSE2.0')then
            write(ie,'(a)')' Error in EndTime'
         else
            write(ie,'(a)')'*** error: specification of DATE2'//
     &                     ' is not correct!'
            write(ie,'(a)')'*** DATE2 must be of the form'//
     &                     ' YYYYMMDDHHMM !'
         endif 
         RETURN
      endif
      minutes2=JULIAM2(iyr2,imo2,idy2,ihr2,imn2)
      if(minutes2.lt.minutes1)then
         if(gseformat.eq.'GSE2.0')then
            write(ie,'(a)')' Error: EndTime is *before* StartTime'
         else
            write(ie,'(a)')'*** error: DATE2 is before DATE1 !'
         endif
         RETURN
      endif
c
c     arrive here, if all tests were successful:
c
      ideltamin=minutes2-minutes1
      resultok=.true.
      RETURN
c
  998 if(gseformat.eq.'GSE2.0')then
         write(ie,*)' *** error or unexpected end during read'
      else
         write(ie,*)'*** error or unexpected end during read'
      endif
      RETURN
c
      end ! of subr. checkcdat
c
      subroutine FTPGSE2HANDLER(it,sendfile,sourceid,
     &                          ftpdir,cipnumber,userftpdir,
     &                          forcedftp,rejectmail)
c
c     set-up the response mail in case the requesting person wants to retrieve
c     the AutoDRM-output later via ftp
c
      implicit none
      integer k, trimlen, iyr,imo,idy,ihr,imn, trimbeg, it
      real sec
      character*80 sendfile, ftpdir, filna, line, userftpdir
      character string*200, filename*100, cdate*20, msgid*30,
     &          cipnumber*50, csec*10, reflin*80, sourceid*7
      logical forcedftp, rejectmail
c
c     store response here locally and send info to requester:
c
      if(.not.rejectmail)then
         call DATETIMEUTC(cdate)
         call NUMDATETIME(cdate,iyr,imo,idy,ihr,imn,sec)
         write(filna,'(i4.4,4i2.2)') iyr,imo,idy,ihr,imn
         write(csec,'(f5.2)') sec
         filna=filna(1:trimlen(filna))//
     &                      csec(trimbeg(csec):trimlen(csec))
         filename=ftpdir(1:trimlen(ftpdir))//filna(1:trimlen(filna))
         string='/bin/cp '//sendfile(1:trimlen(sendfile))//' '
     &                 //filename(1:trimlen(filename))
         call system(string)
         string='chmod a+r '//filename(1:trimlen(filename))
      endif
c
      call FREEUNIT(k)
      open(k,file=sendfile,status='old')
      write(k,'(a)')'BEGIN     GSE2.0'
      write(k,'(a)')'MSG_TYPE  data'
      call MAKEMSGID(msgid,sourceid)    ! our msgid
      write(k,'(a)')'MSG_ID    '//msgid
      rewind(it)
      call GETMSGID(it,msgid,reflin)    ! received msgid
      write(k,'(a)')'REF_ID    '//msgid
      if(rejectmail)then
            write(k,'(a)')'DATA_TYPE error_log'
            write(k,'(a)')' The original request could not be satisfied'
            write(k,'(a)')' using e-mail due to the large size of the'
            write(k,'(a)')' requested information; FTP was tried '//
     &                    'instead.'
            write(k,'(a)')' However, even for FTP-usage the size of'
            write(k,'(a)')' the requested information was too large.'
            write(k,'(a)')' THEREFORE YOUR REQUEST WAS REJECTED!'
            write(k,'(a)')' Please submit a new request that will'
            write(k,'(a)')' result in a smaller response-file.'
      else
         write(k,'(a)')'DATA_TYPE ftp_log'
         line='FTP_FILE '//cipnumber(1:trimlen(cipnumber))//' GUEST '//
     &                  userftpdir(1:trimlen(userftpdir))//' '//
     &                  filna(1:trimlen(filna))
         write(k,'(a)') line(1:trimlen(line))
         if(forcedftp)then
            write(k,'(a)')' The original request could not be satisfied'
            write(k,'(a)')' using e-mail due to the large size of the'
            write(k,'(a)')' requested information; FTP was used '//
     &                    'instead.'
         else
            write(k,'(a)')' You have chosen the FTP-option.'
         endif
         write(k,'(a)')' Therefore the response to your request was'
         write(k,'(a)')' stored on our computer.'
         write(k,'(a)')' Please log into our anonymous ftp account'
         write(k,'(a)')' (user=ftp, password=ftp) and retrieve the '//
     &                 'data.'
         write(k,'(a)')' Data will be removed after 24 hours.'
      endif
      write(k,'(a)')'STOP'
      close(k)
c
      RETURN
      end ! of subr. ftpgse2handler
c
      subroutine SUBSTCHARS(string,char1,char2)
      implicit none
c
c     In a given input string, substitute all appearing char1 by a char2
c
      integer i
      character*(*) string
      character char1*1, char2*1
c 
      do i=1,LEN(string)
         if(string(i:i).eq.char1) string(i:i)=char2
      enddo
c
      RETURN
      end ! of subr. substchars
c 
      subroutine TIMEDIFF(cdatetime1,cdatetime2,ideltasec)
c
c     Input:  2 date/time strings (output from DATETIME or DATETIMEUTC)
c     Output: difference in seconds between cdatetime1 and cdatetime2
c
c     Urs Kradolfer, 27.4.95
c
      implicit none
      integer juliam2, iyr,imo,idy,ihr,imn, minutes1,minutes2, ideltasec
      real sec1,sec2
      character*(*) cdatetime1,cdatetime2
c
      call NUMDATETIME(cdatetime1,iyr,imo,idy,ihr,imn,sec1)
      minutes1=JULIAM2(iyr,imo,idy,ihr,imn)
      call NUMDATETIME(cdatetime2,iyr,imo,idy,ihr,imn,sec2)
      minutes2=JULIAM2(iyr,imo,idy,ihr,imn)
c
      ideltasec=60*(minutes2-minutes1)+NINT(sec2-sec1)
c
      end ! of subr. timediff
c
      subroutine USERVALIDITY(useraddress,allowfile,denyfile,validuser)
c
c     Check if access to AutoDRM is restricted or not; if access is
c     restricted, check if e-mail address of sender is valid or not.
c
c     If file $HOME/adm/autodrm.allow exists and contains other than
c     comment lines, then *only* users whose e-mail address appears in this
c     file, are valid users. In this case, file $home/adm/autodrm.deny is
c     not checked, because it is assumed that every e-mail address that does
c     not appear in this file is not a valid address.
c
c     If file $HOME/adm/autodrm.deny exists, users whose e-mail address
c     (or part of it) appear in this file are denied access to AutoDRM.
c
c     If neither file exists or if they contain comment-lines only, global
c     access is permitted.
c
c                                                      Urs Kradolfer, 7.6.95
c
      implicit none
      integer i, trimlen
      character*(*) useraddress,allowfile,denyfile
      character line*80, mailaddress*100
      logical validuser, lexist, restricted
c
      mailaddress=useraddress
      call CASEFOLD(mailaddress)
      validuser=.true.
      restricted=.false.
c
c     Does file autodrm.allow exist? Are there non-comment lines
c     giving e-mail addresses of valid users?
c     (This would imply that any other users are not authorized!)
c
      inquire(file=allowfile,exist=lexist)
      if(lexist)then
         call FREEUNIT(i)
         open(i,file=allowfile,status='old')
  1      read(i,'(a)',end=10) line
         if(line(1:1).eq.'#') goto 1
         if(line.eq.' ') goto 1
         restricted=.true. ! non-comment line found --> only valid users allowed
         validuser=.false.
         call CASEFOLD(line)
         if(INDEX(mailaddress,line(1:trimlen(line))).gt.0)then
            validuser=.true.
            goto 10
         endif
         goto 1
 10      close(i)
         if(restricted) RETURN  ! do not consult file autodrm.deny anymore
      endif
c
c     Does file autodrm.deny exist? Are there any non-comment lines
c     giving e-mail addresses of unauthorized users?
c
      inquire(file=denyfile,exist=lexist)
      if(lexist)then
         call FREEUNIT(i)
         open(i,file=denyfile,status='old')
  2      read(i,'(a)',end=20) line
         if(line(1:1).eq.'#') goto 2
         if(line.eq.' ') goto 2
         call CASEFOLD(line)
         if(INDEX(mailaddress,line(1:trimlen(line))).gt.0)then
            validuser=.false.
            goto 20
         endif
         goto 2
 20      close(i)
      endif
c
      RETURN
c
      end ! of subr. uservalidity
c
      subroutine CHECKSTALIST(stalist,il,ie,gseformat)
      implicit none
      integer i, k, nsta, trimbeg, trimlen, il,ie
      character station(100)*5
      character*1024 stalist, cc, c
      character gseformat*10
      logical public
c
c     check, what stations are in the list:
c
      nsta=0
      cc=stalist
      if(stalist.ne.' ')then
         do i=1,100
            k=INDEX(cc,',')
            if(k.gt.0)then
               c=cc(trimbeg(cc):k-1)
               nsta=nsta+1
               station(i)=c(1:trimlen(c))
               cc(1:k)=' '
            else
               nsta=nsta+1
               station(i)=cc(trimbeg(cc):trimlen(cc))
               if(station(i).eq.' ') nsta=nsta-1
               goto 10
            endif
         enddo
      endif
  10  continue
      if(nsta.gt.0.and.station(1).eq.'*')then
         stalist='*'
         RETURN
      endif
      if(nsta.gt.0)then
         stalist=' '
         do i=1,nsta
            call PUBLICSTATION(station(i),public)
            if(public)then
               if(stalist.ne.' ')then
                  stalist=stalist(1:trimlen(stalist))//','
               endif
               stalist=stalist(1:trimlen(stalist))//' '//station(i)
            else
               if(gseformat.eq.'GSE2.0')then
                  write(ie,'(a)')' *** station '//station(i)//
     &                                            ' not available'
               else
                  write(ie,'(a)')'*** station '//station(i)//
     &                                           ' not available'
               endif
            endif
         enddo
         if(gseformat.eq.'GSE2.0')then
            write(il,'(a)')' sta_list after check is: '//
     &                      stalist(1:trimlen(stalist))
         else
            write(il,'(a)')'### sta_list after check is: '//
     &                      stalist(1:trimlen(stalist))
         endif
      endif
c
      end ! of subr. checkstalist
c 
      subroutine TIMECLEAR(iyr,imo,iday,ihr,minu,sec,itime)
c
c     Urs Kradolfer, Winter 1987/88
c
      implicit none
c
      integer iyr,iyr1,imo,iday,ihr,minu, juliam2,itime
      real sec,sec1
c
      if(iyr.lt.1900)then
         iyr1=iyr+1900
      else
         iyr1=iyr
      endif
      itime=JULIAM2(iyr1,imo,iday,ihr,minu)
   1  sec1=sec
      if(sec.lt.0)then
         sec=sec1+60.
         itime=itime-1
      endif
      if(sec.gt.60.)then
         sec=sec1-60.
         itime=itime+1
      endif
      if(sec.lt.0.0.or.sec.gt.60.0) goto 1
      call DATUM2(itime,iyr1,imo,iday,ihr,minu)
      if(iyr.lt.1900)then
         iyr=iyr1-1900    ! if input-year was of form  87  give it out so !
      else
         iyr=iyr1
      endif
c
      return
c
      end ! of subr. timeclear
c
      integer function juliam2(IYR,IMO,IDY,IHR,IMN)
c
C     UMRECHNEN VON JAHR-MONAT-TAG-STUNDEN-MINUTEN IN MINUTEN:
C     (WENN IMN 4-BYTE INTEGER, DANN JAHR < 4000)
c
c     originally from Manfred Baer (maybe also from Fredi Hardmeier)
c
c     corrected for the Y2K-problem   19.5.1999 / Urs Kradolfer
c
      implicit none
      integer KMO(12), leap, iyr,imo,idy,ihr,imn, 
     &        ky,km,kd, ky4,ky1,ky0,kl, l
      DATA KMO/0,31,59,90,120,151,181,212,243,273,304,334/
      DATA LEAP/1/
      KY= IYR
      KM= IMO
      KD= IDY
      IF(KM.LE.0) KM= 1
10    JULIAM2= 365*KY
      KD= KMO(KM)+KD
      KY4= KY/4
      KY1= KY/100
cuk99      KY0= KY/1000
      KY0= KY/400
      KL= LEAP*(KY4-KY1+KY0)
      L=0
cuk99      IF(KY4*4.EQ.KY.AND.(KY1*100.NE.KY.OR.KY0*1000.EQ.KY))L= LEAP
      IF((KY4*4.EQ.KY.AND.KY1*100.NE.KY).OR.KY0*400.EQ.KY)L= LEAP
      IF(L.NE.0.AND.KM.LT.3) KL= KL-LEAP
      JULIAM2= JULIAM2+KD+KL
      JULIAM2= JULIAM2*24+IHR
      JULIAM2= JULIAM2*60+IMN
      return
      END ! of integer funct. juliam2
c
      subroutine DATUM2(ITF,IYR,IMO,IDY,IHR,IMN)
c
C     UMRECHNEN DES DATUMS IN MINUTEN (CF. JULIAM2) IN YR-MO-DY-HR-MI
C     (MIT IMN<2**31, JAHR < 4000
c
c
c     originally from Manfred Baer (maybe also from Fredi Hardmeier)
c     modified by Urs Kradolfer, 26.6.92: avoid changing DATA-value ( kmo(2) )
c
c     corrected for the Y2K-problem   19.5.1999 / Urs Kradolfer
c
      implicit none
      integer KMO(12), kmo1(12),kmo2(12), iyr,imo,idy,ihr,imn,
     &        id,iyr4,iyrh,iyrt,ld,l,i
      INTEGER ITF,K,KH
      DATA KMO1/31,28,31,30,31,30,31,31,30,31,30,31/
      DATA KMO2/31,29,31,30,31,30,31,31,30,31,30,31/
      K= ITF/60
      IMN= ITF-K*60
      KH= K/24
      IHR= K-KH*24
      IYR= KH/365
5     ID= KH-IYR*365
      L= 0
      IYR4= IYR/4
      IYRH= IYR/100
cuk99      IYRT= IYR/1000
      IYRT= IYR/400
      LD= IYR4-IYRH+IYRT
cuk99      IF(IYR4*4.EQ.IYR.AND.(IYRH*100.NE.IYR.OR.IYRT*1000.EQ.IYR)) L= 1
      IF((IYR4*4.EQ.IYR.AND.IYRH*100.NE.IYR).OR.IYRT*400.EQ.IYR) L= 1
      ID= ID-LD+L
      IF(ID.GT.0) GOTO 10
      IYR= IYR-1
      GOTO 5
cuk 10   KMO(2)= 28+L
 10   continue
      if(l.eq.0)then
         do i=1,12
            kmo(i)=kmo1(i)
         enddo
      else
         do i=1,12
            kmo(i)=kmo2(i)     ! schaltjahr
         enddo
      endif
      DO I=1,12
         ID= ID- KMO(I)
         IF(ID.LE.0) GOTO 30
      enddo
      I=12
30    IDY= ID+KMO(I)
      IMO= I
      RETURN
      end ! of subr. datum2
c
      subroutine CHECKEMAILADDRESS(emailaddress)
c
c     anti-spam measures: mails are incoming, with lines starting with
c     E-MAIL, but no e-mail address following (instead, other text follows).
c     Such lines should not be treated as valid AutoDRM E-MAIL commands.
c
      implicit none
      integer trimbeg, trimlen, n,m
      character*(*) emailaddress
      character e*100
c
      e=emailaddress
      call CASEFOLD(e)
c
c     treat lines like:   e-mail addresses
c
      if(e(1:7).eq.'address') goto 9
      if(e(1:6).eq.'adress') goto 9
      if(e(1:6).eq.'adress') goto 9
c
c     treat lines like:   e-mail campaigns produce staggering response rates!
c
      n=trimbeg(e)
      m=trimlen(e)
      if(INDEX(e(n:m),' ').gt.0) goto 9
c
      RETURN
c
  9   emailaddress=' '
      RETURN
c
      end ! of subr. checkemailaddress
c
      subroutine SPAMCHECK(tempfile,spamheadfile,spambodyfile,logfile,
     &                     cexecstartttime,spam)
      implicit none
      integer it, is, nb,nh, i, ir, iend, trimlen, n, nblank
      character*(*) tempfile,spamheadfile,spambodyfile, cexecstartttime,
     &              logfile
      character*80 line, spamtext(2,100), spamt, firstline, spamlogfile,
     &             spamtB, lineB
      character string*500
      logical spam, hexist,bexist, readingheader
c
      inquire(file=spamheadfile,exist=hexist)
      inquire(file=spambodyfile,exist=bexist)
      if(.not.(hexist.and.bexist)) RETURN
c
      call FREEUNIT(it)
      open(it,file=tempfile,status='old')
      read(it,'(a)') firstline
      rewind(it)
c
      call FREEUNIT(is)
      open(is,file=spamheadfile,status='old')
      i=0
   1  read(is,'(a)',end=2) line
      if(line(1:1).eq.'#') goto 1
      i=i+1
      spamtext(1,i)=line
      if(i.lt.100) goto 1
   2  nh=i
      close(is)
      open(is,file=spambodyfile,status='old')
      i=0
   3  read(is,'(a)',end=4) line
      if(line(1:1).eq.'#') goto 3
      i=i+1
      spamtext(2,i)=line
      if(i.lt.100) goto 3
   4  nb=i
      close(is)
c
      readingheader=.true.       ! we start with reading the header of the mail
      ir=1
      iend=nh
  10  read(it,'(a)',end=888) line
      if(line.eq.' ')then
         readingheader=.false.   ! from now on we read the message body
         ir=2
         iend=nb
         goto 10
      endif
      do i=1,iend
         spamt=spamtext(ir,i)
         if(spamt(1:1).eq.'=')then
            if(line.eq.spamt(2:)) goto 999
         else
            if(spamt(1:1).eq.'~')then
               read(spamt(2:),*) nblank
               if(INDEX(line,' ').gt.nblank) goto 999
            endif
            spamtB=spamt
            call CASEFOLD(spamtB)
            lineB=line
            call CASEFOLD(lineB)
            if(spamtB(1:1).eq.'^')then
               n=trimlen(spamtB)
               if(lineB(1:n-1).eq.spamtB(2:n)) goto 999
            else
               if(INDEX(lineB,spamtB(1:trimlen(spamtB))).gt.0) goto 999
            endif
         endif
      enddo
c
      goto 10
c
 888  close(it)
      RETURN
c
 999  close(it)
      spam=.true.
c
c     make entry in logfile...
c
      spamlogfile='spam.log'
      call FREEFILE(spamlogfile)
      call FILES(spamlogfile,'new')
      call FREEUNIT(is)
      open(is,file=spamlogfile,status='unknown')
      write(is,'(a)')'SPAM :'//cexecstartttime//' '//firstline(1:53)
      n=trimlen(line)
      if(n.gt.74) n=74
      write(is,'(a)')' spam:'//line(1:n)
      close(is)
      string='cat '//spamlogfile(1:trimlen(spamlogfile))//
     &       ' >> '//logfile(1:trimlen(logfile))
      call system(string)
c
      RETURN
c
      end ! of subr. spamcheck
c
