      subroutine WRITEBULLETIN(is,il,ie,timestring,
     &                         clatminmax, clonminmax,
     &                         cdepthminmax, cndefminmax,
     &                         cnstaminmax, cgapminmax,
     &                         cmagtypelist,cmagminmax, cbulltype,
     &                         outputtype,
     &                         gseformat, bulletinformat, stalist,
     &                         resultok,comment)
c
c     (cbulltype heisst bei bex.f origtype)
c
c     PURPOSE of this subroutine:
c
c     Write specified bulletins to file-unit 'is'
c
c     INPUT-Parameter:
c
c     is         : Output-unit (file must be opened before calling this routine)
c                  where output of this subroutine should be written to.
c                  File should not be closed in this routine!
c     il         : Output-unit where logging-comment can be written to
c                  as e.g.: write(il,'(a)')' checking other data archive now...'
c                  File should not be closed in this routine!
c                  According to GSE2.0 format rules the first character in
c                  log-lines must be blank!
c     ie         : Output-unit where error messages can be written to
c                  as e.g.: write(ie,'(a)')' no data found for this station'
c                  File should not be closed in this routine!
c                  According to GSE2.0 format rules the first character in
c                  error-log-lines must be blank!
c     timestring : Date/Time interval specified; example:
c                  TIME 1998/01/01 00:00:00.0 TO 1998/02/24
c     gseformat  : Either 'GSE2.0' or 'GSE1.0' (= old GSE-format)
c     stalist    : List of stations (comma-separated, wildcards allowed)
c
c     OUTPUT-Parameter:
c
c     resultok   : .true. or .false., depending on success of this routine
c                  This value *must* be set on return
c     comment    : Reports completion status on RETURN 
c                  - 'Command <xyz> processed.'
c                  - 'no data found'
c                  - 'Command not yet implemented'
c                  'comment' should not be blank on return
c
      implicit none
c
      integer is, il, ie, ic, trimlen, io
      character comment*80, gseformat*10, bulletinformat*10,
     &          timestring*70
      character*50 clatminmax, clonminmax, cdepthminmax, cndefminmax,
     &             cnstaminmax, cmagtypelist, cmagminmax, cgapminmax,
     &             cbulltype, outputtype
      character controlfile*80, string*200, line*200, outfile*80
      character*1024 stalist
      logical resultok
c
      comment=' '
      resultok=.false.
c
      controlfile='bex.cntl'
      call FREEFILE(controlfile)
      call FILES(controlfile,'new')
      call FREEUNIT(ic)
      open(ic,file=controlfile,status='unknown')
      write(ic,'(a)')'# controlfile for bulletin extract program'
      if(timestring.ne.' ') 
     &             write(ic,'(a)') timestring(1:trimlen(timestring))
      if(clatminmax.ne.' ') 
     &             write(ic,'(a)') clatminmax(1:trimlen(clatminmax))
      if(clonminmax.ne.' ') 
     &             write(ic,'(a)') clonminmax(1:trimlen(clonminmax))
      if(cdepthminmax.ne.' ') 
     &             write(ic,'(a)') cdepthminmax(1:trimlen(cdepthminmax))
      if(cndefminmax.ne.' ') 
     &             write(ic,'(a)') cndefminmax(1:trimlen(cndefminmax))
      if(cnstaminmax.ne.' ') 
     &             write(ic,'(a)') cnstaminmax(1:trimlen(cnstaminmax))
      if(cmagtypelist.ne.' ') 
     &             write(ic,'(a)') cmagtypelist(1:trimlen(cmagtypelist))
      if(cmagminmax.ne.' ') 
     &             write(ic,'(a)') cmagminmax(1:trimlen(cmagminmax))
      if(cgapminmax.ne.' ') 
     &             write(ic,'(a)') cgapminmax(1:trimlen(cgapminmax))
      if(stalist.ne.' ') 
     &             write(ic,'(a)')'STA_LIST '//
     &                             stalist(1:trimlen(stalist))
c     BULL_TYPE idc_ael
      if(cbulltype.ne.' ') 
     &             write(ic,'(a)')'origtype '//
     &             cbulltype(10:trimlen(cbulltype))
      if(outputtype.eq.'BULLETIN') write(6,'(a)')'bulletin'
      if(outputtype.eq.'ORIGIN') write(6,'(a)')'origin'
      if(outputtype.eq.'EVENT') write(6,'(a)')'event'
      if(outputtype.eq.'ARRIVAL') write(6,'(a)')'arrival'
c
      close(ic)
c
      string='/users/kradi/detec/bex.exe '//
     &       controlfile(1:trimlen(controlfile))//
     &       ' SED'
      call system(string)
c
      call FREEUNIT(io)
      outfile='bex.out'
      call FILES(outfile,'new')
      open(io,file='bex.out',status='old')
  1   read(io,'(a)',err=888,end=1000) line
      write(is,'(a)') line(1:trimlen(line))
      goto 1
c
 888  continue
c
      if(.not.resultok)then
         comment='BULLETIN: read-error on outputfile '//
     &           'of bulletin-extractor'
         RETURN
      endif
c
1000  continue
      resultok=.true.
      if(outputtype.eq.'BULLETIN')
     &         comment='BULLETIN: command <bulletin> processed.'
      if(outputtype.eq.'ORIGIN')
     &         comment='ORIGIN: command <origin> processed.'
      if(outputtype.eq.'EVENT')
     &         comment='EVENT: command <event> processed.'
      if(outputtype.eq.'ARRIVAL')
     &         comment='ARRIVAL: command <arrival> processed.'
      RETURN
c
      end ! of subr. writebulletin
c
