      subroutine WRITERESPONSE(is,il,ie,cdat1,
     &                        stalist,chanlist,auxlist,resultok,comment)
c
c     PURPOSE of this subroutine:
c
c     Write specified responses to file-unit 'is'
c
c     INPUT-Parameter:
c
c     is         : Output-unit (file must be opened before calling this routine)
c                  where output of this subroutine should be written to.
c                  File should not be closed in this routine!
c     il         : Output-unit where logging-comment can be written to
c                  as e.g.: write(il,'(a)')' response for channel found'
c                  File should not be closed in this routine!
c                  According to GSE2.0 format rules the first character in
c                  log-lines must be blank!
c     ie         : Output-unit where error messages can be written to
c                  as e.g.: write(ie,'(a)')' no response found for this channel'
c                  File should not be closed in this routine!
c                  According to GSE2.0 format rules the first character in
c                  error-log-lines must be blank!
c     cdat1      : DateTime for which response should be got; 
c                  Format  YYYYMMDDHHMM - if no DateTime is given, current
c                  local time is assumed
c     stalist    : List of stations (comma-separated, wildcards allowed)
c     chanlist   : List of channels (comma-separated, wildcards allowed)
c     auxlist    : List of auxIDs (comma-separated, wildcards allowed)
c                  (in most cases, this value can be neglected)
c
c     OUTPUT-Parameter:
c
c     resultok   : .true. or .false., depending on success of this routine
c                  This value *must* be set on return
c     comment    : Reports completion status on RETURN 
c                  - 'Command <xyz> processed.'
c                  - 'no data found'
c                  - 'Command not yet implemented'
c                  'comment' should not be blank on return
c
      implicit none
      integer is, il, ie
      character*1024 stalist, chanlist, auxlist
      character comment*80, cdat1*12
      logical resultok
c
      resultok=.true.
      comment='Command <response> not (yet) implemented.'
c
      RETURN
      end ! of subr. writeresponse
c
