      subroutine WRITEWAVES4U(is,il,ie,
     &                        clatminmax, clonminmax,
     &                        gseformat, stalist, chanlist,
     &                        resultok,comment)
c
c     This subroutine is a dummy-routine to be used by the SED only.
c
c
c     PURPOSE of this subroutine:
c
c     Write waves4u output to file-unit 'is'
c
c     INPUT-Parameter:
c
c     is         : Output-unit (file must be opened before calling this routine)
c                  where output of this subroutine should be written to.
c                  File should not be closed in this routine!
c     il         : Output-unit where logging-comment can be written to
c                  as e.g.: write(il,'(a)')' checking other data archive now...'
c                  File should not be closed in this routine!
c                  According to GSE2.0 format rules the first character in
c                  log-lines must be blank!
c     ie         : Output-unit where error messages can be written to
c                  as e.g.: write(ie,'(a)')' no data found for this station'
c                  File should not be closed in this routine!
c                  According to GSE2.0 format rules the first character in
c                  error-log-lines must be blank!
c     clatminmax : 
c     clonminmax : 
c     
c     gseformat  : Either 'GSE2.0' or 'GSE1.0' (= old GSE-format)
c     stalist    : List of stations (comma-separated, wildcards allowed)
c     chanlist   : List of channels (comma-separated, wildcards allowed)
c
c     OUTPUT-Parameter:
c
c     resultok   : .true. or .false., depending on success of this routine
c                  This value *must* be set on return
c     comment    : Reports completion status on RETURN 
c                  - 'Command <xyz> processed.'
c                  - 'no data found'
c                  - 'Command not yet implemented'
c                  'comment' should not be blank on return
c
      implicit none
c
      integer is, il, ie
      character comment*80, gseformat*10
      character*50 clatminmax, clonminmax
      character*1024 stalist, chanlist
      logical resultok
c
      comment=' Waves4u not implemented '
      resultok=.false.
c
      RETURN
c
      end ! of subr. writewaves4u
c
